/* Generated by re2c 0.13.5 on Fri Jul 25 08:52:54 2008 */
#line 1 "Zend/zend_language_scanner.l"
/*
   +----------------------------------------------------------------------+
   | Zend Engine                                                          |
   +----------------------------------------------------------------------+
   | Copyright (c) 1998-2006 Zend Technologies Ltd. (http://www.zend.com) |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.00 of the Zend license,     |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.zend.com/license/2_00.txt.                                |
   | If you did not receive a copy of the Zend license and are unable to  |
   | obtain it through the world-wide-web, please send a note to          |
   | license@zend.com so we can mail you a copy immediately.              |
   +----------------------------------------------------------------------+
   | Authors: Marcus Boerger <helly@php.net>                              |
   |          Nuno Lopes <nlopess@php.net>                                |
   |          Scott MacVicar <scottmac@php.net>                           |
   | Flex version authors:                                                |
   |          Andi Gutmans <andi@zend.com>                                |
   |          Zeev Suraski <zeev@zend.com>                                |
   +----------------------------------------------------------------------+
*/

/* $Id: zend_language_scanner.c,v 1.1.2.19 2008/07/24 23:53:42 moriyoshi Exp $ */

#if 0
# define YYDEBUG(s, c) printf("state: %d char: %c\n", s, c)
#else
# define YYDEBUG(s, c)
#endif

#include "zend_language_scanner_defs.h"

#include <errno.h>
#include "zend.h"
#include "zend_alloc.h"
#include <zend_language_parser.h>
#include "zend_compile.h"
#include "zend_language_scanner.h"
#include "zend_highlight.h"
#include "zend_constants.h"
#include "zend_variables.h"
#include "zend_operators.h"
#include "zend_API.h"
#include "zend_strtod.h"
#include "zend_exceptions.h"
#include "tsrm_virtual_cwd.h"
#include "tsrm_config_common.h"

#define YYCTYPE   unsigned char
#define YYFILL(n) { if (YYCURSOR >= YYLIMIT) return 0; }
#define YYCURSOR  SCNG(yy_cursor)
#define YYLIMIT   SCNG(yy_limit)
#define YYMARKER  SCNG(yy_marker)

#define YYGETCONDITION()  SCNG(yy_state)
#define YYSETCONDITION(s) SCNG(yy_state) = s

#define STATE(name)  yyc##name

/* emulate flex constructs */
#define BEGIN(state) YYSETCONDITION(STATE(state))
#define YYSTATE      YYGETCONDITION()
#define yytext       ((char*)SCNG(yy_text))
#define yyleng       SCNG(yy_leng)
#define yyless(x)    do { YYCURSOR = (unsigned char*)yytext + x; \
                          yyleng   = (unsigned int)x; } while(0)
#define yymore()     goto yymore_restart

/* perform sanity check. If this message is triggered you should
   increase the ZEND_MMAP_AHEAD value in the zend_streams.h file */
#define YYMAXFILL 16
#if ZEND_MMAP_AHEAD < YYMAXFILL
# error ZEND_MMAP_AHEAD should be greater than or equal to YYMAXFILL
#endif

#ifdef HAVE_STDARG_H
# include <stdarg.h>
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

/* Globals Macros */
#define SCNG	LANG_SCNG
#ifdef ZTS
ZEND_API ts_rsrc_id language_scanner_globals_id;
#else
ZEND_API zend_php_scanner_globals language_scanner_globals;
#endif

#define HANDLE_NEWLINES(s, l)													\
do {																			\
	char *p = (s), *boundary = p+(l);											\
																				\
	while (p<boundary) {														\
		if (*p == '\n' || (*p == '\r' && (*(p+1) != '\n'))) {					\
			CG(zend_lineno)++;													\
		}																		\
		p++;																	\
	}																			\
} while (0)

#define HANDLE_NEWLINE(c) \
{ \
	if (c == '\n' || c == '\r') { \
		CG(zend_lineno)++; \
	} \
}

#define ZEND_IS_OCT(c)  ((c)>='0' && (c)<='7')
#define ZEND_IS_HEX(c)  (((c)>='0' && (c)<='9') || ((c)>='a' && (c)<='f') || ((c)>='A' && (c)<='F'))

BEGIN_EXTERN_C()

static void _yy_push_state(int new_state TSRMLS_DC)
{
	zend_stack_push(&SCNG(state_stack), (void *) &YYGETCONDITION(), sizeof(int));
	YYSETCONDITION(new_state);
}

#define yy_push_state(state_and_tsrm) _yy_push_state(yyc##state_and_tsrm)

static void yy_pop_state(TSRMLS_D)
{
	int *stack_state;
	zend_stack_top(&SCNG(state_stack), (void **) &stack_state);
	YYSETCONDITION(*stack_state);
	zend_stack_del_top(&SCNG(state_stack));
}

static void yy_scan_buffer(char *str, unsigned int len TSRMLS_DC)
{
	YYCURSOR       = (YYCTYPE*)str;
	SCNG(yy_start) = YYCURSOR;
	YYLIMIT        = YYCURSOR + len;
}

void startup_scanner(TSRMLS_D)
{
	CG(heredoc) = NULL;
	CG(heredoc_len) = 0;
	CG(doc_comment) = NULL;
	CG(doc_comment_len) = 0;
	zend_llist_init(&SCNG(used_state_stacks), sizeof(zend_stack), (llist_dtor_func_t) zend_stack_destroy, 0);
	zend_stack_init(&SCNG(state_stack));
	zend_llist_add_element(&SCNG(used_state_stacks), &SCNG(state_stack));
}

void shutdown_scanner(TSRMLS_D)
{
	if (CG(heredoc)) {
		efree(CG(heredoc));
		CG(heredoc_len)=0;
	}
	zend_llist_destroy(&SCNG(used_state_stacks));
	RESET_DOC_COMMENT();
}

static int compare_stacks(zend_stack *stack1, zend_stack *stack2)
{
	return (stack1 == stack2);
}

ZEND_API void zend_save_lexical_state(zend_lex_state *lex_state TSRMLS_DC)
{
	lex_state->yy_leng   = SCNG(yy_leng);
	lex_state->yy_start  = SCNG(yy_start);
	lex_state->yy_text   = SCNG(yy_text);
	lex_state->yy_cursor = SCNG(yy_cursor);
	lex_state->yy_marker = SCNG(yy_marker);
	lex_state->yy_limit  = SCNG(yy_limit);

	lex_state->state_stack = SCNG(state_stack);
	zend_stack_init(&SCNG(state_stack));
	zend_llist_add_element(&SCNG(used_state_stacks), &SCNG(state_stack));

	lex_state->in = SCNG(yy_in);
	lex_state->yy_state = YYSTATE;
	lex_state->filename = zend_get_compiled_filename(TSRMLS_C);
	lex_state->lineno = CG(zend_lineno);

#ifdef ZEND_MULTIBYTE
	lex_state->script_org = SCNG(script_org);
	lex_state->script_org_size = SCNG(script_org_size);
	lex_state->script_filtered = SCNG(script_filtered);
	lex_state->script_filtered_size = SCNG(script_filtered_size);
	lex_state->input_filter = SCNG(input_filter);
	lex_state->output_filter = SCNG(output_filter);
	lex_state->script_encoding = SCNG(script_encoding);
	lex_state->internal_encoding = SCNG(internal_encoding);
#endif /* ZEND_MULTIBYTE */
}

ZEND_API void zend_restore_lexical_state(zend_lex_state *lex_state TSRMLS_DC)
{
	SCNG(yy_leng)   = lex_state->yy_leng;
	SCNG(yy_start)  = lex_state->yy_start;
	SCNG(yy_text)   = lex_state->yy_text;
	SCNG(yy_cursor) = lex_state->yy_cursor;
	SCNG(yy_marker) = lex_state->yy_marker;
	SCNG(yy_limit)  = lex_state->yy_limit;

	zend_llist_del_element(&SCNG(used_state_stacks), &SCNG(state_stack), (int (*)(void *, void *)) compare_stacks);
	SCNG(state_stack) = lex_state->state_stack;

	SCNG(yy_in) = lex_state->in;
	YYSETCONDITION(lex_state->yy_state);
	CG(zend_lineno) = lex_state->lineno;
	zend_restore_compiled_filename(lex_state->filename TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	SCNG(script_org) = lex_state->script_org;
	SCNG(script_org_size) = lex_state->script_org_size;
	SCNG(script_filtered) = lex_state->script_filtered;
	SCNG(script_filtered_size) = lex_state->script_filtered_size;
	SCNG(input_filter) = lex_state->input_filter;
	SCNG(output_filter) = lex_state->output_filter;
	SCNG(script_encoding) = lex_state->script_encoding;
	SCNG(internal_encoding) = lex_state->internal_encoding;
#endif /* ZEND_MULTIBYTE */
}

ZEND_API void zend_destroy_file_handle(zend_file_handle *file_handle TSRMLS_DC)
{
	zend_llist_del_element(&CG(open_files), file_handle, (int (*)(void *, void *)) zend_compare_file_handles);
	/* zend_file_handle_dtor() operates on the copy, so we have to NULLify the original here */
	file_handle->opened_path = NULL;
	if (file_handle->free_filename) {
		file_handle->filename = NULL;
	}
}


ZEND_API int open_file_for_scanning(zend_file_handle *file_handle TSRMLS_DC)
{
	char *file_path = NULL, *buf;
	size_t size;

	if (zend_stream_fixup(file_handle, &buf, &size TSRMLS_CC) == FAILURE) {
		return FAILURE;
	}

	zend_llist_add_element(&CG(open_files), file_handle);
	if (file_handle->handle.stream.handle >= (void*)file_handle && file_handle->handle.stream.handle <= (void*)(file_handle+1)) {
		zend_file_handle *fh = (zend_file_handle*)zend_llist_get_last(&CG(open_files));
		size_t diff = (char*)file_handle->handle.stream.handle - (char*)file_handle;
		fh->handle.stream.handle = (void*)(((char*)fh) + diff);
		file_handle->handle.stream.handle = fh->handle.stream.handle;
	}

	/* Reset the scanner for scanning the new file */
	SCNG(yy_in) = file_handle;

	if (size != -1) {
#ifdef ZEND_MULTIBYTE
		if (zend_multibyte_read_script((unsigned char *)buf, size TSRMLS_CC) != 0) {
			return FAILURE;
		}

		SCNG(yy_in) = NULL;

		zend_multibyte_set_filter(NULL TSRMLS_CC);

		if (!SCNG(input_filter)) {
			SCNG(script_filtered) = (unsigned char*)emalloc(SCNG(script_org_size)+1);
			memcpy(SCNG(script_filtered), SCNG(script_org), SCNG(script_org_size)+1);
			SCNG(script_filtered_size) = SCNG(script_org_size);
		} else {
			SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size) TSRMLS_CC);
		}

		yy_scan_buffer((char *)SCNG(script_filtered), SCNG(script_filtered_size) TSRMLS_CC);
#else /* !ZEND_MULTIBYTE */
		yy_scan_buffer(buf, size TSRMLS_CC);
#endif /* ZEND_MULTIBYTE */
	} else {
		zend_error_noreturn(E_COMPILE_ERROR, "zend_stream_mmap() failed");
	}

	BEGIN(INITIAL);

	if (file_handle->opened_path) {
		file_path = file_handle->opened_path;
	} else {
		file_path = file_handle->filename;
	}

	zend_set_compiled_filename(file_path TSRMLS_CC);

	if (CG(start_lineno)) {
		CG(zend_lineno) = CG(start_lineno);
		CG(start_lineno) = 0;
	} else {
		CG(zend_lineno) = 1;
	}

	CG(increment_lineno) = 0;
	return SUCCESS;
}
END_EXTERN_C()


ZEND_API zend_op_array *compile_file(zend_file_handle *file_handle, int type TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = (zend_op_array *) emalloc(sizeof(zend_op_array));
	zend_op_array *original_active_op_array = CG(active_op_array);
	zend_op_array *retval=NULL;
	int compiler_result;
	zend_bool compilation_successful=0;
	znode retval_znode;
	zend_bool original_in_compilation = CG(in_compilation);

	retval_znode.op_type = IS_CONST;
	retval_znode.u.constant.type = IS_LONG;
	retval_znode.u.constant.value.lval = 1;
	Z_UNSET_ISREF(retval_znode.u.constant);
	Z_SET_REFCOUNT(retval_znode.u.constant, 1);

	zend_save_lexical_state(&original_lex_state TSRMLS_CC);

	retval = op_array; /* success oriented */

	if (open_file_for_scanning(file_handle TSRMLS_CC)==FAILURE) {
		if (type==ZEND_REQUIRE) {
			zend_message_dispatcher(ZMSG_FAILED_REQUIRE_FOPEN, file_handle->filename);
			zend_bailout();
		} else {
			zend_message_dispatcher(ZMSG_FAILED_INCLUDE_FOPEN, file_handle->filename);
		}
		compilation_successful=0;
	} else {
		init_op_array(op_array, ZEND_USER_FUNCTION, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
		CG(in_compilation) = 1;
		CG(active_op_array) = op_array;
		compiler_result = zendparse(TSRMLS_C);
		zend_do_return(&retval_znode, 0 TSRMLS_CC);
		CG(in_compilation) = original_in_compilation;
		if (compiler_result==1) { /* parser error */
			zend_bailout();
		}
		compilation_successful=1;
	}

	if (retval) {
		CG(active_op_array) = original_active_op_array;
		if (compilation_successful) {
			pass_two(op_array TSRMLS_CC);
			zend_release_labels(TSRMLS_C);
		} else {
			efree(op_array);
			retval = NULL;
		}
	}
	if (compilation_successful) {
		zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	}
	return retval;
}


zend_op_array *compile_filename(int type, zval *filename TSRMLS_DC)
{
	zend_file_handle file_handle;
	zval tmp;
	zend_op_array *retval;
	char *opened_path = NULL;

	if (filename->type != IS_STRING) {
		tmp = *filename;
		zval_copy_ctor(&tmp);
		convert_to_string(&tmp);
		filename = &tmp;
	}
	file_handle.filename = filename->value.str.val;
	file_handle.free_filename = 0;
	file_handle.type = ZEND_HANDLE_FILENAME;
	file_handle.opened_path = NULL;
	file_handle.handle.fp = NULL;

	retval = zend_compile_file(&file_handle, type TSRMLS_CC);
	if (retval && file_handle.handle.stream.handle) {
		int dummy = 1;

		if (!file_handle.opened_path) {
			file_handle.opened_path = opened_path = estrndup(filename->value.str.val, filename->value.str.len);
		}

		zend_hash_add(&EG(included_files), file_handle.opened_path, strlen(file_handle.opened_path)+1, (void *)&dummy, sizeof(int), NULL);

		if (opened_path) {
			efree(opened_path);
		}
	}
	zend_destroy_file_handle(&file_handle TSRMLS_CC);

	if (filename==&tmp) {
		zval_dtor(&tmp);
	}
	return retval;
}

ZEND_API int zend_prepare_string_for_scanning(zval *str, char *filename TSRMLS_DC)
{
	/* enforce two trailing NULLs for flex... */
	str->value.str.val = safe_erealloc(str->value.str.val, 1, str->value.str.len, ZEND_MMAP_AHEAD);

	memset(str->value.str.val + str->value.str.len, 0, ZEND_MMAP_AHEAD);

	SCNG(yy_in)=NULL;

#ifdef ZEND_MULTIBYTE
	SCNG(script_org) = (unsigned char *)estrdup(str->value.str.val);
	SCNG(script_org_size) = str->value.str.len;

	zend_multibyte_set_filter(CG(internal_encoding) TSRMLS_CC);

	if (!SCNG(input_filter)) {
		SCNG(script_filtered) = (unsigned char*)emalloc(SCNG(script_org_size)+1);
		memcpy(SCNG(script_filtered), SCNG(script_org), SCNG(script_org_size)+1);
		SCNG(script_filtered_size) = SCNG(script_org_size);
	} else {
		SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size) TSRMLS_CC);
	}

	yy_scan_buffer((char *)SCNG(script_filtered), SCNG(script_filtered_size) TSRMLS_CC);	
#else /* !ZEND_MULTIBYTE */
	yy_scan_buffer(str->value.str.val, str->value.str.len TSRMLS_CC);
#endif /* ZEND_MULTIBYTE */

	zend_set_compiled_filename(filename TSRMLS_CC);
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	return SUCCESS;
}


ZEND_API int zend_get_scanned_file_offset(TSRMLS_D)
{
	return SCNG(yy_cursor) - SCNG(yy_start);
}


zend_op_array *compile_string(zval *source_string, char *filename TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = (zend_op_array *) emalloc(sizeof(zend_op_array));
	zend_op_array *original_active_op_array = CG(active_op_array);
	zend_op_array *retval;
	zval tmp;
	int compiler_result;
	zend_bool original_in_compilation = CG(in_compilation);

	if (source_string->value.str.len==0) {
		efree(op_array);
		return NULL;
	}

	CG(in_compilation) = 1;

	tmp = *source_string;
	zval_copy_ctor(&tmp);
	convert_to_string(&tmp);
	source_string = &tmp;

	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (zend_prepare_string_for_scanning(source_string, filename TSRMLS_CC)==FAILURE) {
		efree(op_array);
		retval = NULL;
	} else {
		zend_bool orig_interactive = CG(interactive);

		CG(interactive) = 0;
		init_op_array(op_array, ZEND_EVAL_CODE, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
		CG(interactive) = orig_interactive;
		CG(active_op_array) = op_array;
		BEGIN(ST_IN_SCRIPTING);
		compiler_result = zendparse(TSRMLS_C);

#ifdef ZEND_MULTIBYTE
		if (SCNG(script_org)) {
			efree(SCNG(script_org));
			SCNG(script_org) = NULL;
		}
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
			SCNG(script_filtered) = NULL;
		}
#endif /* ZEND_MULTIBYTE */

		if (compiler_result==1) {
			CG(active_op_array) = original_active_op_array;
			CG(unclean_shutdown)=1;
			retval = NULL;
		} else {
			zend_do_return(NULL, 0 TSRMLS_CC);
			CG(active_op_array) = original_active_op_array;
			pass_two(op_array TSRMLS_CC);
			zend_release_labels(TSRMLS_C);
			retval = op_array;
		}
		zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	}
	zval_dtor(&tmp);
	CG(in_compilation) = original_in_compilation;
	return retval;
}


BEGIN_EXTERN_C()
int highlight_file(char *filename, zend_syntax_highlighter_ini *syntax_highlighter_ini TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_file_handle file_handle;

	file_handle.type = ZEND_HANDLE_FILENAME;
	file_handle.filename = filename;
	file_handle.free_filename = 0;
	file_handle.opened_path = NULL;
	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (open_file_for_scanning(&file_handle TSRMLS_CC)==FAILURE) {
		zend_message_dispatcher(ZMSG_FAILED_HIGHLIGHT_FOPEN, filename);
		return FAILURE;
	}
	zend_highlight(syntax_highlighter_ini TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
#endif /* ZEND_MULTIBYTE */
	zend_destroy_file_handle(&file_handle TSRMLS_CC);
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	return SUCCESS;
}

int highlight_string(zval *str, zend_syntax_highlighter_ini *syntax_highlighter_ini, char *str_name TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zval tmp = *str;

	str = &tmp;
	zval_copy_ctor(str);
	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (zend_prepare_string_for_scanning(str, str_name TSRMLS_CC)==FAILURE) {
		return FAILURE;
	}
	BEGIN(INITIAL);
	zend_highlight(syntax_highlighter_ini TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
#endif /* ZEND_MULTIBYTE */
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	zval_dtor(str);
	return SUCCESS;
}
END_EXTERN_C()

#ifdef ZEND_MULTIBYTE

BEGIN_EXTERN_C()
ZEND_API void zend_multibyte_yyinput_again(zend_encoding_filter old_input_filter, zend_encoding *old_encoding TSRMLS_DC)
{
	size_t offset, original_offset, length, free_flag, new_len;
	unsigned char *p;
	zend_encoding *new_encoding;

	/* calculate current position */
	offset = original_offset = YYCURSOR - SCNG(yy_start);
	if (old_input_filter && original_offset > 0) {
		new_encoding = SCNG(script_encoding);
		SCNG(script_encoding) = old_encoding;
		do {
			(old_input_filter)(&p, &length, SCNG(script_org), offset TSRMLS_CC);
			if (!p) {
				SCNG(script_encoding) = new_encoding;
				return;
			}
			efree(p);
			if (length > original_offset) {
				offset--;
			} else if (length < original_offset) {
				offset++;
			}
		} while (original_offset != length);
		SCNG(script_encoding) = new_encoding;
	}

	/* convert and set */
	if (!SCNG(input_filter)) {
		length = SCNG(script_org_size) - offset;
		p = SCNG(script_org) + offset;
		free_flag = 0;
	} else {
		SCNG(input_filter)(&p, &length, SCNG(script_org) + offset, SCNG(script_org_size) - offset TSRMLS_CC);
		free_flag = 1;
	}

	new_len = original_offset + length;

	if (new_len > YYLIMIT - SCNG(yy_start)) {
		unsigned char *new_yy_start = erealloc(SCNG(yy_start), new_len);
		SCNG(yy_cursor) = new_yy_start + (SCNG(yy_cursor) - SCNG(yy_start));
		SCNG(yy_marker) = new_yy_start + (SCNG(yy_marker) - SCNG(yy_start));
		SCNG(yy_text) = new_yy_start + (SCNG(yy_text) - SCNG(yy_start));
		SCNG(yy_start) = new_yy_start;
		SCNG(script_filtered) = new_yy_start;
		SCNG(script_filtered_size) = new_len;
	}

	SCNG(yy_limit) = SCNG(yy_start) + new_len;
	memmove(SCNG(yy_start) + original_offset, p, length);

	if (free_flag) {
		efree(p);
	}
}


ZEND_API int zend_multibyte_yyinput(zend_file_handle *file_handle, char *buf, size_t len TSRMLS_DC)
{
	size_t n;

	if (CG(interactive) == 0) {
		if (zend_stream_fixup(file_handle, &buf, &len TSRMLS_CC) == FAILURE) {
			return FAILURE;
		}
		n = len;
		return n;
	}

	/* interactive */
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
	}
	SCNG(script_org) = NULL;
	SCNG(script_org_size) = 0;

	/* TODO: support widechars */
	if (zend_stream_fixup(file_handle, &buf, &len TSRMLS_CC) == FAILURE) {
		return FAILURE;
	}
	n = len;

	SCNG(script_org_size) = n;
	SCNG(script_org) = (unsigned char*)emalloc(SCNG(script_org_size) + 1);
	memcpy(SCNG(script_org), buf, n);

	return n;
}


ZEND_API int zend_multibyte_read_script(unsigned char *buf, size_t n TSRMLS_DC)
{
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
	}
	SCNG(script_org_size) = n;
	SCNG(script_org) = (unsigned char*)erealloc(SCNG(script_org), SCNG(script_org_size));
	memcpy(SCNG(script_org) + SCNG(script_org_size) - n, buf, n);
	
	SCNG(script_org) = (unsigned char*)erealloc(SCNG(script_org), SCNG(script_org_size) + 1);
	*(SCNG(script_org)+SCNG(script_org_size)) = '\0';

	return 0;
}


# define zend_copy_value(zendlval, yytext, yyleng) \
	if (SCNG(output_filter)) { \
		size_t sz = 0; \
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)yytext, (size_t)yyleng TSRMLS_CC); \
		zendlval->value.str.len = sz; \
	} else { \
		zendlval->value.str.val = (char *) estrndup(yytext, yyleng); \
		zendlval->value.str.len = yyleng; \
	}
#else /* ZEND_MULTIBYTE */
# define zend_copy_value(zendlval, yytext, yyleng) \
	zendlval->value.str.val = (char *)estrndup(yytext, yyleng); \
	zendlval->value.str.len = yyleng;
#endif /* ZEND_MULTIBYTE */

static void zend_scan_escape_string(zval *zendlval, char *str, int len, char quote_type TSRMLS_DC)
{
	register char *s, *t;
	char *end;

	ZVAL_STRINGL(zendlval, str, len, 1);

	/* convert escape sequences */
	s = t = zendlval->value.str.val;
	end = s+zendlval->value.str.len;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (s >= end) {
				*t++ = '\\';
				break;
			}

			switch(*s) {
				case 'n':
					*t++ = '\n';
					zendlval->value.str.len--;
					break;
				case 'r':
					*t++ = '\r';
					zendlval->value.str.len--;
					break;
				case 't':
					*t++ = '\t';
					zendlval->value.str.len--;
					break;
				case 'f':
					*t++ = '\f';
					zendlval->value.str.len--;
					break;
				case 'v':
					*t++ = '\v';
					zendlval->value.str.len--;
					break;
				case '"':
				case '`':
					if (*s != quote_type) {
						*t++ = '\\';
						*t++ = *s;
						break;
					}
				case '\\':
				case '$':
					*t++ = *s;
					zendlval->value.str.len--;
					break;
				case 'x':
				case 'X':
					if (ZEND_IS_HEX(*(s+1))) {
						char hex_buf[3] = { 0, 0, 0 };

						zendlval->value.str.len--; /* for the 'x' */

						hex_buf[0] = *(++s);
						zendlval->value.str.len--;
						if (ZEND_IS_HEX(*(s+1))) {
							hex_buf[1] = *(++s);
							zendlval->value.str.len--;
						}
						*t++ = (char) strtol(hex_buf, NULL, 16);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
				default:
					/* check for an octal */
					if (ZEND_IS_OCT(*s)) {
						char octal_buf[4] = { 0, 0, 0, 0 };

						octal_buf[0] = *s;
						zendlval->value.str.len--;
						if (ZEND_IS_OCT(*(s+1))) {
							octal_buf[1] = *(++s);
							zendlval->value.str.len--;
							if (ZEND_IS_OCT(*(s+1))) {
								octal_buf[2] = *(++s);
								zendlval->value.str.len--;
							}
						}
						*t++ = (char) strtol(octal_buf, NULL, 8);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		size_t sz = 0;
		s = zendlval->value.str.val;
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)s, (size_t)zendlval->value.str.len TSRMLS_CC);
		zendlval->value.str.len = sz;
		efree(s);
	}
#endif /* ZEND_MULTIBYTE */
}


int lex_scan(zval *zendlval TSRMLS_DC)
{
restart:
	SCNG(yy_text) = YYCURSOR;

yymore_restart:

	/* detect EOF */
	if (YYCURSOR >= YYLIMIT) {
		/* special case */
		if (YYSTATE == STATE(ST_COMMENT) || YYSTATE == STATE(ST_DOC_COMMENT)) {
			zend_error(E_COMPILE_WARNING, "Unterminated comment starting line %d", CG(zend_lineno));
		}

		return 0;
	}

	/* ignore first line when it's started with a # */
	if (YYCURSOR == SCNG(yy_start) && *YYCURSOR == '#') {
		while (++YYCURSOR < YYLIMIT) {
			if (*YYCURSOR == '\n') {
				++YYCURSOR;
				goto restart;
			}

			if (*YYCURSOR == '\r') {
				if (++YYCURSOR < YYLIMIT && *YYCURSOR == '\n') { /* match \r\n as single newline */
					++YYCURSOR;
				}
				goto restart;
			}
		}

		return 0; /* EOF */
	}


#line 861 "Zend/zend_language_scanner.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if (YYGETCONDITION() < 8) {
		if (YYGETCONDITION() < 4) {
			if (YYGETCONDITION() < 2) {
				if (YYGETCONDITION() < 1) {
					goto yyc_ST_IN_SCRIPTING;
				} else {
					goto yyc_ST_LOOKING_FOR_PROPERTY;
				}
			} else {
				if (YYGETCONDITION() < 3) {
					goto yyc_ST_BACKQUOTE;
				} else {
					goto yyc_ST_DOUBLE_QUOTES;
				}
			}
		} else {
			if (YYGETCONDITION() < 6) {
				if (YYGETCONDITION() < 5) {
					goto yyc_ST_HEREDOC;
				} else {
					goto yyc_ST_LOOKING_FOR_VARNAME;
				}
			} else {
				if (YYGETCONDITION() < 7) {
					goto yyc_ST_VAR_OFFSET;
				} else {
					goto yyc_INITIAL;
				}
			}
		}
	} else {
		if (YYGETCONDITION() < 12) {
			if (YYGETCONDITION() < 10) {
				if (YYGETCONDITION() < 9) {
					goto yyc_ST_ONE_LINE_COMMENT;
				} else {
					goto yyc_ST_COMMENT;
				}
			} else {
				if (YYGETCONDITION() < 11) {
					goto yyc_ST_DOC_COMMENT;
				} else {
					goto yyc_ST_START_HEREDOC;
				}
			}
		} else {
			if (YYGETCONDITION() < 14) {
				if (YYGETCONDITION() < 13) {
					goto yyc_ST_END_HEREDOC;
				} else {
					goto yyc_ST_START_NOWDOC;
				}
			} else {
				if (YYGETCONDITION() < 15) {
					goto yyc_ST_NOWDOC;
				} else {
					goto yyc_ST_END_NOWDOC;
				}
			}
		}
	}
/* *********************************** */
yyc_INITIAL:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
		};

		YYDEBUG(0, *YYCURSOR);
		YYFILL(8);
		yych = *YYCURSOR;
		if (yych != '<') goto yy4;
		YYDEBUG(2, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '?') {
			if (yych == '%') goto yy7;
			if (yych >= '?') goto yy5;
		} else {
			if (yych <= 'S') {
				if (yych >= 'S') goto yy9;
			} else {
				if (yych == 's') goto yy9;
			}
		}
yy3:
		YYDEBUG(3, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1627 "Zend/zend_language_scanner.l"
		{

inline_char_handler:

	while (1) {
		YYCTYPE *ptr = memchr(YYCURSOR, '<', YYLIMIT - YYCURSOR);

		if (ptr == NULL) {
			YYCURSOR = YYLIMIT;
			yyleng   = YYCURSOR - SCNG(yy_text);
			break;

		} else {
			YYCURSOR = ptr + 1;

			/* stop if it may be an opening tag (<?, <%, <script>). this condition is not optimal though */
			if (YYCURSOR < YYLIMIT && (*YYCURSOR == '?' || *YYCURSOR == '%' || *YYCURSOR == 's')) {
				--YYCURSOR;
				yyleng = YYCURSOR - SCNG(yy_text);
				break;
			}
		}
	}

#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		int readsize;
		size_t sz = 0;
		readsize = SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)yytext, (size_t)yyleng TSRMLS_CC);
		zendlval->value.str.len = sz;
		if (readsize < yyleng) {
			yyless(readsize);
		}
	} else {
	  zendlval->value.str.val = (char *) estrndup(yytext, yyleng);
	  zendlval->value.str.len = yyleng;
	}
#else /* !ZEND_MULTIBYTE */
	zendlval->value.str.val = (char *) estrndup(yytext, yyleng);
 	zendlval->value.str.len = yyleng;
#endif
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_INLINE_HTML;
}
#line 1030 "Zend/zend_language_scanner.c"
yy4:
		YYDEBUG(4, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy3;
yy5:
		YYDEBUG(5, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == '=') goto yy45;
		} else {
			if (yych <= 'P') goto yy47;
			if (yych == 'p') goto yy47;
		}
yy6:
		YYDEBUG(6, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1615 "Zend/zend_language_scanner.l"
		{
	if (CG(short_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG;
	} else {
		goto inline_char_handler;
	}
}
#line 1060 "Zend/zend_language_scanner.c"
yy7:
		YYDEBUG(7, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy43;
		YYDEBUG(8, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1592 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG;
	} else {
		goto inline_char_handler;
	}
}
#line 1079 "Zend/zend_language_scanner.c"
yy9:
		YYDEBUG(9, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy11;
		if (yych == 'c') goto yy11;
yy10:
		YYDEBUG(10, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 0) {
			goto yy3;
		} else {
			goto yy6;
		}
yy11:
		YYDEBUG(11, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy12;
		if (yych != 'r') goto yy10;
yy12:
		YYDEBUG(12, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy13;
		if (yych != 'i') goto yy10;
yy13:
		YYDEBUG(13, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy14;
		if (yych != 'p') goto yy10;
yy14:
		YYDEBUG(14, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy15;
		if (yych != 't') goto yy10;
yy15:
		YYDEBUG(15, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy10;
		if (yych == 'l') goto yy10;
		goto yy17;
yy16:
		YYDEBUG(16, *YYCURSOR);
		++YYCURSOR;
		YYFILL(8);
		yych = *YYCURSOR;
yy17:
		YYDEBUG(17, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy16;
		}
		if (yych == 'L') goto yy18;
		if (yych != 'l') goto yy10;
yy18:
		YYDEBUG(18, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy19;
		if (yych != 'a') goto yy10;
yy19:
		YYDEBUG(19, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy20;
		if (yych != 'n') goto yy10;
yy20:
		YYDEBUG(20, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy21;
		if (yych != 'g') goto yy10;
yy21:
		YYDEBUG(21, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy22;
		if (yych != 'u') goto yy10;
yy22:
		YYDEBUG(22, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy23;
		if (yych != 'a') goto yy10;
yy23:
		YYDEBUG(23, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy24;
		if (yych != 'g') goto yy10;
yy24:
		YYDEBUG(24, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy25;
		if (yych != 'e') goto yy10;
yy25:
		YYDEBUG(25, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(26, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy10;
			if (yych <= '\n') goto yy25;
			if (yych <= '\f') goto yy10;
			goto yy25;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy10;
				goto yy25;
			} else {
				if (yych != '=') goto yy10;
			}
		}
yy27:
		YYDEBUG(27, *YYCURSOR);
		++YYCURSOR;
		YYFILL(5);
		yych = *YYCURSOR;
		YYDEBUG(28, *YYCURSOR);
		if (yych <= '!') {
			if (yych <= '\f') {
				if (yych <= 0x08) goto yy10;
				if (yych <= '\n') goto yy27;
				goto yy10;
			} else {
				if (yych <= '\r') goto yy27;
				if (yych == ' ') goto yy27;
				goto yy10;
			}
		} else {
			if (yych <= 'O') {
				if (yych <= '"') goto yy30;
				if (yych == '\'') goto yy31;
				goto yy10;
			} else {
				if (yych <= 'P') goto yy29;
				if (yych != 'p') goto yy10;
			}
		}
yy29:
		YYDEBUG(29, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy42;
		if (yych == 'h') goto yy42;
		goto yy10;
yy30:
		YYDEBUG(30, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy39;
		if (yych == 'p') goto yy39;
		goto yy10;
yy31:
		YYDEBUG(31, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy32;
		if (yych != 'p') goto yy10;
yy32:
		YYDEBUG(32, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy33;
		if (yych != 'h') goto yy10;
yy33:
		YYDEBUG(33, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy34;
		if (yych != 'p') goto yy10;
yy34:
		YYDEBUG(34, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '\'') goto yy10;
yy35:
		YYDEBUG(35, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(36, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy10;
			if (yych <= '\n') goto yy35;
			if (yych <= '\f') goto yy10;
			goto yy35;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy10;
				goto yy35;
			} else {
				if (yych != '>') goto yy10;
			}
		}
		YYDEBUG(37, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(38, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1556 "Zend/zend_language_scanner.l"
		{
	HANDLE_NEWLINES(yytext, yyleng);
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(ST_IN_SCRIPTING);
	return T_OPEN_TAG;
}
#line 1274 "Zend/zend_language_scanner.c"
yy39:
		YYDEBUG(39, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy40;
		if (yych != 'h') goto yy10;
yy40:
		YYDEBUG(40, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy41;
		if (yych != 'p') goto yy10;
yy41:
		YYDEBUG(41, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy35;
		goto yy10;
yy42:
		YYDEBUG(42, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy35;
		if (yych == 'p') goto yy35;
		goto yy10;
yy43:
		YYDEBUG(43, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(44, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1566 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG_WITH_ECHO;
	} else {
		goto inline_char_handler;
	}
}
#line 1313 "Zend/zend_language_scanner.c"
yy45:
		YYDEBUG(45, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(46, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1579 "Zend/zend_language_scanner.l"
		{
	if (CG(short_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG_WITH_ECHO;
	} else {
		goto inline_char_handler;
	}
}
#line 1331 "Zend/zend_language_scanner.c"
yy47:
		YYDEBUG(47, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy48;
		if (yych != 'h') goto yy10;
yy48:
		YYDEBUG(48, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy49;
		if (yych != 'p') goto yy10;
yy49:
		YYDEBUG(49, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy10;
			if (yych >= '\v') goto yy10;
		} else {
			if (yych <= '\r') goto yy52;
			if (yych != ' ') goto yy10;
		}
yy50:
		YYDEBUG(50, *YYCURSOR);
		++YYCURSOR;
yy51:
		YYDEBUG(51, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1605 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINE(yytext[yyleng-1]);
	BEGIN(ST_IN_SCRIPTING);
	return T_OPEN_TAG;
}
#line 1367 "Zend/zend_language_scanner.c"
yy52:
		YYDEBUG(52, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy50;
		goto yy51;
	}
/* *********************************** */
yyc_ST_BACKQUOTE:
	{
		static const unsigned char yybm[] = {
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  32,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144,  16,  16,  16,  16,  16,  16, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  16,   0,  16,  16, 144, 
			  0, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  64,  16,  16,  16, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
		};
		YYDEBUG(53, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy58;
		}
		if (yych <= '[') goto yy55;
		if (yych <= '\\') goto yy61;
		if (yych <= 'z') goto yy62;
		goto yy56;
yy55:
		YYDEBUG(55, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy68;
		}
		if (yych <= '^') {
			if (yych <= 'Z') {
				if (yych <= '@') goto yy58;
				goto yy74;
			} else {
				if (yych == '\\') goto yy67;
				goto yy58;
			}
		} else {
			if (yych <= 'z') {
				if (yych == '`') goto yy71;
				goto yy74;
			} else {
				if (yych <= '{') goto yy77;
				if (yych <= '~') goto yy58;
				goto yy74;
			}
		}
yy56:
		YYDEBUG(56, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy72;
		}
		if (yych == '$') goto yy57;
		if (yych == '`') goto yy71;
		goto yy59;
yy57:
		YYDEBUG(57, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2012 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_CURLY_OPEN;
}
#line 1464 "Zend/zend_language_scanner.c"
yy58:
		YYDEBUG(58, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy59:
		YYDEBUG(59, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy58;
		}
		if (yych <= '[') goto yy66;
		if (yych <= '\\') goto yy61;
		if (yych >= '{') goto yy64;
yy60:
		YYDEBUG(60, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2037 "Zend/zend_language_scanner.l"
		{
	zend_scan_escape_string(zendlval, yytext, yyleng, '`' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1487 "Zend/zend_language_scanner.c"
yy61:
		YYDEBUG(61, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		goto yy58;
yy62:
		YYDEBUG(62, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(63, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2173 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	return '`';
}
#line 1504 "Zend/zend_language_scanner.c"
yy64:
		YYDEBUG(64, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy58;
		}
		if (yych <= '[') goto yy65;
		if (yych <= '\\') goto yy61;
		if (yych <= 'z') goto yy71;
		goto yy72;
yy65:
		YYDEBUG(65, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 1) {
			if (yyaccept <= 0) {
				goto yy57;
			} else {
				goto yy60;
			}
		} else {
			if (yyaccept <= 2) {
				goto yy70;
			} else {
				goto yy76;
			}
		}
yy66:
		YYDEBUG(66, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy68;
		}
		if (yych <= '^') {
			if (yych <= 'Z') {
				if (yych <= '@') goto yy58;
				goto yy65;
			} else {
				if (yych != '\\') goto yy58;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy65;
				goto yy71;
			} else {
				if (yych <= '{') goto yy65;
				if (yych <= '~') goto yy58;
				goto yy65;
			}
		}
yy67:
		YYDEBUG(67, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		goto yy58;
yy68:
		YYDEBUG(68, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(69, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy68;
		}
		if (yych <= '^') {
			if (yych <= 'Z') {
				if (yych <= '@') goto yy58;
			} else {
				if (yych == '\\') goto yy67;
				goto yy58;
			}
		} else {
			if (yych <= '`') {
				if (yych >= '`') goto yy71;
			} else {
				if (yych <= '{') goto yy70;
				if (yych <= '~') goto yy58;
			}
		}
yy70:
		YYDEBUG(70, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2042 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	zend_scan_escape_string(zendlval, yytext, yyleng, '`' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1598 "Zend/zend_language_scanner.c"
yy71:
		YYDEBUG(71, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy70;
yy72:
		YYDEBUG(72, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(73, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy58;
		}
		if (yych <= '[') goto yy70;
		if (yych <= '\\') goto yy61;
		if (yych <= 'z') goto yy71;
		goto yy72;
yy74:
		YYDEBUG(74, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(75, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy74;
		}
		if (yych == '-') goto yy79;
		if (yych == '[') goto yy80;
yy76:
		YYDEBUG(76, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1695 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1638 "Zend/zend_language_scanner.c"
yy77:
		YYDEBUG(77, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(78, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1349 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 1649 "Zend/zend_language_scanner.c"
yy79:
		YYDEBUG(79, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy82;
		goto yy65;
yy80:
		YYDEBUG(80, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(81, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1687 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1668 "Zend/zend_language_scanner.c"
yy82:
		YYDEBUG(82, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy65;
			if (yych <= 'Z') goto yy83;
			if (yych <= '^') goto yy65;
		} else {
			if (yych <= '`') goto yy65;
			if (yych <= 'z') goto yy83;
			if (yych <= '~') goto yy65;
		}
yy83:
		YYDEBUG(83, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(84, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1677 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1694 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_COMMENT:
	{
		static const unsigned char yybm[] = {
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(85, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy87;
		}
		goto yy90;
yy87:
		YYDEBUG(87, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(88, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy87;
		}
		YYDEBUG(89, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1787 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1755 "Zend/zend_language_scanner.c"
yy90:
		YYDEBUG(90, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '/') goto yy92;
		YYDEBUG(91, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1805 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1766 "Zend/zend_language_scanner.c"
yy92:
		YYDEBUG(92, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(93, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1799 "Zend/zend_language_scanner.l"
		{
	HANDLE_NEWLINES(yytext, yyleng);
	BEGIN(ST_IN_SCRIPTING);
	return T_COMMENT;
}
#line 1778 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_DOC_COMMENT:
	{
		static const unsigned char yybm[] = {
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(94, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy96;
		}
		goto yy99;
yy96:
		YYDEBUG(96, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(97, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy96;
		}
		YYDEBUG(98, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1787 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1839 "Zend/zend_language_scanner.c"
yy99:
		YYDEBUG(99, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '/') goto yy101;
		YYDEBUG(100, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1805 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 1850 "Zend/zend_language_scanner.c"
yy101:
		YYDEBUG(101, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(102, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1791 "Zend/zend_language_scanner.l"
		{
	CG(doc_comment) = estrndup(yytext, yyleng);
	CG(doc_comment_len) = yyleng;
	HANDLE_NEWLINES(yytext, yyleng);
	BEGIN(ST_IN_SCRIPTING);
	return T_DOC_COMMENT;
}
#line 1864 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_DOUBLE_QUOTES:
	{
		static const unsigned char yybm[] = {
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,   0,  16,  32,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144,  16,  16,  16,  16,  16,  16, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  16,   0,  16,  16, 144, 
			 16, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144,  64,  16,  16,  16, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
			144, 144, 144, 144, 144, 144, 144, 144, 
		};
		YYDEBUG(103, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy108;
		}
		if (yych <= '#') goto yy112;
		if (yych <= '$') goto yy105;
		if (yych <= 'z') goto yy111;
		goto yy106;
yy105:
		YYDEBUG(105, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy118;
		}
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych == '"') goto yy121;
				goto yy108;
			} else {
				if (yych <= 'Z') goto yy124;
				if (yych <= '[') goto yy108;
				goto yy117;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy124;
				goto yy108;
			} else {
				if (yych <= 'z') goto yy124;
				if (yych <= '{') goto yy127;
				if (yych <= '~') goto yy108;
				goto yy124;
			}
		}
yy106:
		YYDEBUG(106, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy122;
		}
		if (yych == '"') goto yy121;
		if (yych != '$') goto yy109;
yy107:
		YYDEBUG(107, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2012 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_CURLY_OPEN;
}
#line 1957 "Zend/zend_language_scanner.c"
yy108:
		YYDEBUG(108, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy109:
		YYDEBUG(109, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy108;
		}
		if (yych <= '#') goto yy110;
		if (yych <= '$') goto yy116;
		if (yych <= 'z') goto yy111;
		goto yy114;
yy110:
		YYDEBUG(110, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2019 "Zend/zend_language_scanner.l"
		{
	zend_scan_escape_string(zendlval, yytext, yyleng, '"' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1981 "Zend/zend_language_scanner.c"
yy111:
		YYDEBUG(111, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		goto yy108;
yy112:
		YYDEBUG(112, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(113, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2167 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	return '"';
}
#line 1998 "Zend/zend_language_scanner.c"
yy114:
		YYDEBUG(114, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy108;
		}
		if (yych <= '#') goto yy121;
		if (yych <= '$') goto yy115;
		if (yych <= 'z') goto yy111;
		goto yy122;
yy115:
		YYDEBUG(115, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 1) {
			if (yyaccept <= 0) {
				goto yy107;
			} else {
				goto yy110;
			}
		} else {
			if (yyaccept <= 2) {
				goto yy120;
			} else {
				goto yy126;
			}
		}
yy116:
		YYDEBUG(116, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy118;
		}
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych == '"') goto yy121;
				goto yy108;
			} else {
				if (yych <= 'Z') goto yy115;
				if (yych <= '[') goto yy108;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy115;
				goto yy108;
			} else {
				if (yych <= '{') goto yy115;
				if (yych <= '~') goto yy108;
				goto yy115;
			}
		}
yy117:
		YYDEBUG(117, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		goto yy108;
yy118:
		YYDEBUG(118, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(119, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy118;
		}
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych == '"') goto yy121;
				goto yy108;
			} else {
				if (yych <= 'Z') goto yy120;
				if (yych <= '[') goto yy108;
				goto yy117;
			}
		} else {
			if (yych <= '`') {
				if (yych != '_') goto yy108;
			} else {
				if (yych <= '{') goto yy120;
				if (yych <= '~') goto yy108;
			}
		}
yy120:
		YYDEBUG(120, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2030 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	zend_scan_escape_string(zendlval, yytext, yyleng, '"' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 2095 "Zend/zend_language_scanner.c"
yy121:
		YYDEBUG(121, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy120;
yy122:
		YYDEBUG(122, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(123, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy108;
		}
		if (yych <= '#') goto yy121;
		if (yych <= '$') goto yy120;
		if (yych <= 'z') goto yy111;
		goto yy122;
yy124:
		YYDEBUG(124, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(125, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy124;
		}
		if (yych == '-') goto yy129;
		if (yych == '[') goto yy130;
yy126:
		YYDEBUG(126, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1695 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2135 "Zend/zend_language_scanner.c"
yy127:
		YYDEBUG(127, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(128, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1349 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 2146 "Zend/zend_language_scanner.c"
yy129:
		YYDEBUG(129, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy132;
		goto yy115;
yy130:
		YYDEBUG(130, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(131, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1687 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2165 "Zend/zend_language_scanner.c"
yy132:
		YYDEBUG(132, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy115;
			if (yych <= 'Z') goto yy133;
			if (yych <= '^') goto yy115;
		} else {
			if (yych <= '`') goto yy115;
			if (yych <= 'z') goto yy133;
			if (yych <= '~') goto yy115;
		}
yy133:
		YYDEBUG(133, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(134, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1677 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2191 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_END_HEREDOC:
	YYDEBUG(135, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(137, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(138, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2001 "Zend/zend_language_scanner.l"
	{
	SCNG(yy_text) = (unsigned char *)(Z_STRVAL_P(zendlval) = CG(heredoc));
	SCNG(yy_leng) = Z_STRLEN_P(zendlval) = CG(heredoc_len);
	CG(heredoc) = NULL;
	CG(heredoc_len) = 0;
	BEGIN(ST_IN_SCRIPTING);
	return T_END_HEREDOC;
}
#line 2211 "Zend/zend_language_scanner.c"
/* *********************************** */
yyc_ST_END_NOWDOC:
	YYDEBUG(139, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(141, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(142, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2156 "Zend/zend_language_scanner.l"
	{
	SCNG(yy_text) = (unsigned char*)(Z_STRVAL_P(zendlval) = CG(heredoc));
	SCNG(yy_leng) = Z_STRLEN_P(zendlval) = CG(heredoc_len);
	CG(heredoc) = NULL;
	CG(heredoc_len) = 0;
	BEGIN(ST_IN_SCRIPTING);
	return T_END_NOWDOC;
}
#line 2230 "Zend/zend_language_scanner.c"
/* *********************************** */
yyc_ST_HEREDOC:
	{
		static const unsigned char yybm[] = {
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,  16,   4,   4,  32,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,  64,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			 12,  12,  12,  12,  12,  12,  12,  12, 
			 12,  12,   4,   4,   4,   4,   4,   4, 
			  4,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   4,   0,   4,   4,   8, 
			  4,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8, 128,   4,   4,   4,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
		};
		YYDEBUG(143, *YYCURSOR);
		YYFILL(2);
		yych = *(YYMARKER = YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '[') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			if (yych <= '@') goto yy146;
			goto yy151;
		} else {
			if (yych <= '\\') goto yy153;
			if (yych == '{') goto yy147;
			goto yy151;
		}
yy145:
		YYDEBUG(145, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2056 "Zend/zend_language_scanner.l"
		{
	zend_scan_escape_string(zendlval, yytext, yyleng, 0 TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 2292 "Zend/zend_language_scanner.c"
yy146:
		YYDEBUG(146, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych == '$') goto yy191;
				goto yy150;
			} else {
				if (yych <= 'Z') goto yy195;
				if (yych <= '[') goto yy150;
				goto yy184;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy195;
				goto yy150;
			} else {
				if (yych <= 'z') goto yy195;
				if (yych <= '{') goto yy198;
				if (yych <= '~') goto yy150;
				goto yy195;
			}
		}
yy147:
		YYDEBUG(147, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy153;
			} else {
				if (yych == '{') goto yy193;
				goto yy149;
			}
		}
yy148:
		YYDEBUG(148, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2012 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_CURLY_OPEN;
}
#line 2344 "Zend/zend_language_scanner.c"
yy149:
		YYDEBUG(149, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy150:
		YYDEBUG(150, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '[') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			if (yych <= '@') goto yy190;
		} else {
			if (yych <= '\\') goto yy153;
			if (yych == '{') goto yy189;
		}
yy151:
		YYDEBUG(151, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(152, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '@') {
			if (yych <= '$') {
				if (yych == '\r') goto yy156;
				if (yych <= '#') goto yy149;
				goto yy183;
			} else {
				if (yych <= '9') {
					if (yych <= '/') goto yy149;
					goto yy151;
				} else {
					if (yych == ';') goto yy181;
					goto yy149;
				}
			}
		} else {
			if (yych <= '_') {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy151;
					goto yy149;
				} else {
					if (yych <= '\\') goto yy153;
					if (yych <= '^') goto yy149;
					goto yy151;
				}
			} else {
				if (yych <= 'z') {
					if (yych <= '`') goto yy149;
					goto yy151;
				} else {
					if (yych <= '{') goto yy182;
					if (yych <= '~') goto yy149;
					goto yy151;
				}
			}
		}
yy153:
		YYDEBUG(153, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych == '\r') goto yy156;
		goto yy149;
yy154:
		YYDEBUG(154, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(155, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '[') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			if (yych <= '@') goto yy162;
			goto yy158;
		} else {
			if (yych <= '\\') goto yy163;
			if (yych == '{') goto yy160;
			goto yy158;
		}
yy156:
		YYDEBUG(156, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(157, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '[') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			if (yych <= '@') goto yy162;
		} else {
			if (yych <= '\\') goto yy163;
			if (yych == '{') goto yy160;
		}
yy158:
		YYDEBUG(158, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(159, *YYCURSOR);
		if (yych <= ';') {
			if (yych <= '#') {
				if (yych <= '\n') {
					if (yych <= '\t') goto yy149;
					goto yy174;
				} else {
					if (yych == '\r') goto yy174;
					goto yy149;
				}
			} else {
				if (yych <= '/') {
					if (yych <= '$') goto yy173;
					goto yy149;
				} else {
					if (yych <= '9') goto yy158;
					if (yych <= ':') goto yy149;
					goto yy170;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy149;
					goto yy158;
				} else {
					if (yych == '\\') goto yy171;
					goto yy149;
				}
			} else {
				if (yych <= 'z') {
					if (yych == '`') goto yy149;
					goto yy158;
				} else {
					if (yych <= '{') goto yy172;
					if (yych <= '~') goto yy149;
					goto yy158;
				}
			}
		}
yy160:
		YYDEBUG(160, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy163;
			} else {
				if (yych == '{') goto yy168;
				goto yy149;
			}
		}
yy161:
		YYDEBUG(161, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 1) {
			if (yyaccept <= 0) {
				goto yy145;
			} else {
				goto yy148;
			}
		} else {
			if (yyaccept <= 2) {
				goto yy167;
			} else {
				goto yy197;
			}
		}
yy162:
		YYDEBUG(162, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			goto yy165;
		} else {
			if (yych == '\\') goto yy164;
			goto yy161;
		}
yy163:
		YYDEBUG(163, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych == '\r') goto yy156;
		goto yy149;
yy164:
		YYDEBUG(164, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych == '\r') goto yy156;
		goto yy149;
yy165:
		YYDEBUG(165, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(166, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			goto yy165;
		} else {
			if (yych == '\\') goto yy164;
		}
yy167:
		YYDEBUG(167, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2061 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	zend_scan_escape_string(zendlval, yytext, yyleng, 0 TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 2601 "Zend/zend_language_scanner.c"
yy168:
		YYDEBUG(168, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(169, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
			goto yy167;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy163;
			} else {
				if (yych == '{') goto yy168;
				goto yy149;
			}
		}
yy170:
		YYDEBUG(170, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '#') {
			if (yych <= '\n') {
				if (yych <= '\t') goto yy149;
				goto yy174;
			} else {
				if (yych == '\r') goto yy174;
				goto yy149;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '$') goto yy173;
				if (yych <= '[') goto yy149;
			} else {
				if (yych == '{') goto yy172;
				goto yy149;
			}
		}
yy171:
		YYDEBUG(171, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych == '\r') goto yy156;
		goto yy149;
yy172:
		YYDEBUG(172, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
			goto yy161;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy171;
			} else {
				if (yych == '{') goto yy179;
				goto yy149;
			}
		}
yy173:
		YYDEBUG(173, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			goto yy176;
		} else {
			if (yych == '\\') goto yy178;
			goto yy161;
		}
yy174:
		YYDEBUG(174, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(175, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1961 "Zend/zend_language_scanner.l"
		{
	char *end = yytext + yyleng - 1;

	if (end[-1] == ';') {
		end--;
		yyleng--;
	}

	if (yyleng > CG(heredoc_len) && !memcmp(end - CG(heredoc_len), CG(heredoc), CG(heredoc_len))) {
		int len = yyleng - CG(heredoc_len) - 2; /* 2 for newline before and after label */

		/* May have matched fooLABEL; make sure there's a newline before it */
		if (yytext[len] != '\n') {
			if (yytext[len] != '\r') {
				yyless(yyleng - 1);
				yymore();
			}
		} else if (len > 0 && yytext[len - 1] == '\r') {
			len--; /* Windows newline */
		}

		/* Go back before last label char, to match in ST_END_HEREDOC state */
		yyless(yyleng - 2);

		/* Subtract the remaining label length. yyleng must include newline
		 * before label, for zend_highlight/strip, tokenizer, etc. */
		yyleng -= CG(heredoc_len) - 1;

		CG(increment_lineno) = 1; /* For newline before label */
		BEGIN(ST_END_HEREDOC);
		zend_scan_escape_string(zendlval, yytext, len, 0 TSRMLS_CC);
		return T_ENCAPSED_AND_WHITESPACE;
	} else {
		/* Go back to end of label, so the next match works correctly in case of
		 * a variable or another label at the beginning of the next line */
		yyless(yyleng - 1);
		yymore();
	}
}
#line 2740 "Zend/zend_language_scanner.c"
yy176:
		YYDEBUG(176, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(177, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			goto yy176;
		} else {
			if (yych != '\\') goto yy167;
		}
yy178:
		YYDEBUG(178, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych == '\r') goto yy156;
		goto yy149;
yy179:
		YYDEBUG(179, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(180, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
			goto yy167;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy171;
			} else {
				if (yych == '{') goto yy179;
				goto yy149;
			}
		}
yy181:
		YYDEBUG(181, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '[') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			if (yych <= '@') goto yy183;
			goto yy151;
		} else {
			if (yych <= '\\') goto yy153;
			if (yych != '{') goto yy151;
		}
yy182:
		YYDEBUG(182, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
			goto yy161;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy153;
			} else {
				if (yych == '{') goto yy187;
				goto yy149;
			}
		}
yy183:
		YYDEBUG(183, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			goto yy185;
		} else {
			if (yych != '\\') goto yy161;
		}
yy184:
		YYDEBUG(184, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych == '\r') goto yy156;
		goto yy149;
yy185:
		YYDEBUG(185, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(186, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			goto yy185;
		} else {
			if (yych == '\\') goto yy184;
			goto yy167;
		}
yy187:
		YYDEBUG(187, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(188, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
			goto yy167;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy153;
			} else {
				if (yych == '{') goto yy187;
				goto yy149;
			}
		}
yy189:
		YYDEBUG(189, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
			goto yy161;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy153;
			} else {
				if (yych == '{') goto yy193;
				goto yy149;
			}
		}
yy190:
		YYDEBUG(190, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
		} else {
			if (yych == '\\') goto yy184;
			goto yy161;
		}
yy191:
		YYDEBUG(191, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(192, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy149;
		}
		if (yych <= '@') {
			if (yych <= '\f') goto yy154;
			if (yych <= '\r') goto yy156;
			goto yy191;
		} else {
			if (yych == '\\') goto yy184;
			goto yy167;
		}
yy193:
		YYDEBUG(193, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(194, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy154;
		}
		if (yych <= '$') {
			if (yych == '\r') goto yy156;
			if (yych <= '#') goto yy149;
			goto yy167;
		} else {
			if (yych <= '\\') {
				if (yych <= '[') goto yy149;
				goto yy153;
			} else {
				if (yych == '{') goto yy193;
				goto yy149;
			}
		}
yy195:
		YYDEBUG(195, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(196, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '-') goto yy200;
			} else {
				if (yych <= '9') goto yy195;
				if (yych >= 'A') goto yy195;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '[') goto yy201;
				if (yych >= '_') goto yy195;
			} else {
				if (yych <= '`') goto yy197;
				if (yych <= 'z') goto yy195;
				if (yych >= 0x7F) goto yy195;
			}
		}
yy197:
		YYDEBUG(197, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1695 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 3006 "Zend/zend_language_scanner.c"
yy198:
		YYDEBUG(198, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(199, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1349 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 3017 "Zend/zend_language_scanner.c"
yy200:
		YYDEBUG(200, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy203;
		goto yy161;
yy201:
		YYDEBUG(201, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(202, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1687 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 3036 "Zend/zend_language_scanner.c"
yy203:
		YYDEBUG(203, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy161;
			if (yych <= 'Z') goto yy204;
			if (yych <= '^') goto yy161;
		} else {
			if (yych <= '`') goto yy161;
			if (yych <= 'z') goto yy204;
			if (yych <= '~') goto yy161;
		}
yy204:
		YYDEBUG(204, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(205, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1677 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 3062 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_IN_SCRIPTING:
	{
		static const unsigned char yybm[] = {
			/* table 1 .. 8: 0 */
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2, 194,  66,   2,   2,  66,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			194,   2,   0,   2,   4,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			 58,  58,  58,  58,  58,  58,  58,  58, 
			 58,  58,   2,   2,   2,   2,   2,   2, 
			  2,  42,  42,  42,  42,  42,  42,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,   2,   0,   2,   2,  10, 
			  2,  42,  42,  42,  42,  42,  42,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,   1,   2,   2,   2,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			 10,  10,  10,  10,  10,  10,  10,  10, 
			/* table 9 .. 9: 256 */
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128,   0, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(206, *YYCURSOR);
		YYFILL(16);
		yych = *YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x1F:
		case '\\':	goto yy266;
		case '\t':
		case '\n':
		case '\r':
		case ' ':	goto yy224;
		case '!':	goto yy235;
		case '"':	goto yy260;
		case '#':	goto yy258;
		case '$':	goto yy247;
		case '%':	goto yy241;
		case '&':	goto yy242;
		case '\'':	goto yy262;
		case '(':	goto yy229;
		case ')':
		case ',':
		case ';':
		case '@':
		case '[':
		case ']':
		case '~':	goto yy248;
		case '*':	goto yy238;
		case '+':	goto yy234;
		case '-':	goto yy222;
		case '.':	goto yy240;
		case '/':	goto yy239;
		case '0':	goto yy254;
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':	goto yy256;
		case ':':	goto yy226;
		case '<':	goto yy236;
		case '=':	goto yy232;
		case '>':	goto yy237;
		case '?':	goto yy249;
		case 'A':
		case 'a':	goto yy217;
		case 'B':
		case 'b':	goto yy219;
		case 'C':
		case 'c':	goto yy212;
		case 'D':
		case 'd':	goto yy210;
		case 'E':
		case 'e':	goto yy208;
		case 'F':
		case 'f':	goto yy211;
		case 'G':
		case 'g':	goto yy220;
		case 'I':
		case 'i':	goto yy215;
		case 'L':
		case 'l':	goto yy233;
		case 'N':
		case 'n':	goto yy227;
		case 'O':
		case 'o':	goto yy245;
		case 'P':
		case 'p':	goto yy221;
		case 'R':
		case 'r':	goto yy213;
		case 'S':
		case 's':	goto yy218;
		case 'T':
		case 't':	goto yy214;
		case 'U':
		case 'u':	goto yy230;
		case 'V':
		case 'v':	goto yy228;
		case 'W':
		case 'w':	goto yy216;
		case 'X':
		case 'x':	goto yy246;
		case '^':	goto yy244;
		case '_':	goto yy231;
		case '`':	goto yy264;
		case '{':	goto yy250;
		case '|':	goto yy243;
		case '}':	goto yy252;
		default:	goto yy257;
		}
yy208:
		YYDEBUG(208, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(-1, yych);
		switch ((yych = *YYCURSOR)) {
		case 'C':
		case 'c':	goto yy802;
		case 'L':
		case 'l':	goto yy803;
		case 'M':
		case 'm':	goto yy804;
		case 'N':
		case 'n':	goto yy805;
		case 'V':
		case 'v':	goto yy806;
		case 'X':
		case 'x':	goto yy807;
		default:	goto yy284;
		}
yy209:
		YYDEBUG(209, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1719 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 3283 "Zend/zend_language_scanner.c"
yy210:
		YYDEBUG(210, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych <= 'H') {
				if (yych == 'E') goto yy784;
				goto yy284;
			} else {
				if (yych <= 'I') goto yy785;
				if (yych <= 'N') goto yy284;
				goto yy786;
			}
		} else {
			if (yych <= 'h') {
				if (yych == 'e') goto yy784;
				goto yy284;
			} else {
				if (yych <= 'i') goto yy785;
				if (yych == 'o') goto yy786;
				goto yy284;
			}
		}
yy211:
		YYDEBUG(211, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych <= 'N') {
				if (yych == 'I') goto yy763;
				goto yy284;
			} else {
				if (yych <= 'O') goto yy764;
				if (yych <= 'T') goto yy284;
				goto yy765;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'i') goto yy763;
				goto yy284;
			} else {
				if (yych <= 'o') goto yy764;
				if (yych == 'u') goto yy765;
				goto yy284;
			}
		}
yy212:
		YYDEBUG(212, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych <= 'K') {
				if (yych == 'A') goto yy735;
				goto yy284;
			} else {
				if (yych <= 'L') goto yy736;
				if (yych <= 'N') goto yy284;
				goto yy737;
			}
		} else {
			if (yych <= 'k') {
				if (yych == 'a') goto yy735;
				goto yy284;
			} else {
				if (yych <= 'l') goto yy736;
				if (yych == 'o') goto yy737;
				goto yy284;
			}
		}
yy213:
		YYDEBUG(213, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy717;
		if (yych == 'e') goto yy717;
		goto yy284;
yy214:
		YYDEBUG(214, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'R') {
			if (yych == 'H') goto yy709;
			if (yych <= 'Q') goto yy284;
			goto yy710;
		} else {
			if (yych <= 'h') {
				if (yych <= 'g') goto yy284;
				goto yy709;
			} else {
				if (yych == 'r') goto yy710;
				goto yy284;
			}
		}
yy215:
		YYDEBUG(215, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych <= 'L') {
				if (yych == 'F') goto yy662;
				goto yy284;
			} else {
				if (yych <= 'M') goto yy664;
				if (yych <= 'N') goto yy665;
				if (yych <= 'R') goto yy284;
				goto yy666;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'f') goto yy662;
				if (yych <= 'l') goto yy284;
				goto yy664;
			} else {
				if (yych <= 'n') goto yy665;
				if (yych == 's') goto yy666;
				goto yy284;
			}
		}
yy216:
		YYDEBUG(216, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy657;
		if (yych == 'h') goto yy657;
		goto yy284;
yy217:
		YYDEBUG(217, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych <= 'M') {
				if (yych == 'B') goto yy639;
				goto yy284;
			} else {
				if (yych <= 'N') goto yy640;
				if (yych <= 'Q') goto yy284;
				if (yych <= 'R') goto yy641;
				goto yy642;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy639;
				if (yych <= 'm') goto yy284;
				goto yy640;
			} else {
				if (yych <= 'q') goto yy284;
				if (yych <= 'r') goto yy641;
				if (yych <= 's') goto yy642;
				goto yy284;
			}
		}
yy218:
		YYDEBUG(218, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'W') {
			if (yych == 'T') goto yy627;
			if (yych <= 'V') goto yy284;
			goto yy628;
		} else {
			if (yych <= 't') {
				if (yych <= 's') goto yy284;
				goto yy627;
			} else {
				if (yych == 'w') goto yy628;
				goto yy284;
			}
		}
yy219:
		YYDEBUG(219, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'Q') {
			if (yych <= '/') {
				if (yych <= '"') {
					if (yych <= '!') goto yy209;
					goto yy620;
				} else {
					if (yych == '\'') goto yy267;
					goto yy209;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy283;
					goto yy209;
				} else {
					if (yych <= '<') goto yy619;
					if (yych <= '@') goto yy209;
					goto yy283;
				}
			}
		} else {
			if (yych <= '`') {
				if (yych <= 'Z') {
					if (yych <= 'R') goto yy621;
					goto yy283;
				} else {
					if (yych == '_') goto yy283;
					goto yy209;
				}
			} else {
				if (yych <= 'r') {
					if (yych <= 'q') goto yy283;
					goto yy621;
				} else {
					if (yych <= 'z') goto yy283;
					if (yych <= '~') goto yy209;
					goto yy283;
				}
			}
		}
yy220:
		YYDEBUG(220, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'L') goto yy609;
			if (yych <= 'N') goto yy284;
			goto yy610;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy284;
				goto yy609;
			} else {
				if (yych == 'o') goto yy610;
				goto yy284;
			}
		}
yy221:
		YYDEBUG(221, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych == 'R') goto yy585;
			if (yych <= 'T') goto yy284;
			goto yy586;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy284;
				goto yy585;
			} else {
				if (yych == 'u') goto yy586;
				goto yy284;
			}
		}
yy222:
		YYDEBUG(222, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '<') {
			if (yych == '-') goto yy581;
		} else {
			if (yych <= '=') goto yy579;
			if (yych <= '>') goto yy583;
		}
yy223:
		YYDEBUG(223, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1338 "Zend/zend_language_scanner.l"
		{
	return yytext[0];
}
#line 3534 "Zend/zend_language_scanner.c"
yy224:
		YYDEBUG(224, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy578;
yy225:
		YYDEBUG(225, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1077 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_WHITESPACE;
}
#line 3551 "Zend/zend_language_scanner.c"
yy226:
		YYDEBUG(226, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == ':') goto yy575;
		goto yy223;
yy227:
		YYDEBUG(227, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'E') {
			if (yych == 'A') goto yy563;
			if (yych <= 'D') goto yy284;
			goto yy564;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy284;
				goto yy563;
			} else {
				if (yych == 'e') goto yy564;
				goto yy284;
			}
		}
yy228:
		YYDEBUG(228, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy560;
		if (yych == 'a') goto yy560;
		goto yy284;
yy229:
		YYDEBUG(229, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy481;
					if (yych <= 0x1F) goto yy223;
					goto yy481;
				} else {
					if (yych <= '@') goto yy223;
					if (yych == 'C') goto yy223;
					goto yy481;
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy481;
					if (yych <= 'H') goto yy223;
					goto yy481;
				} else {
					if (yych == 'O') goto yy481;
					if (yych <= 'Q') goto yy223;
					goto yy481;
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'b') {
					if (yych == 'U') goto yy481;
					if (yych <= '`') goto yy223;
					goto yy481;
				} else {
					if (yych == 'd') goto yy481;
					if (yych <= 'e') goto yy223;
					goto yy481;
				}
			} else {
				if (yych <= 'o') {
					if (yych == 'i') goto yy481;
					if (yych <= 'n') goto yy223;
					goto yy481;
				} else {
					if (yych <= 's') {
						if (yych <= 'q') goto yy223;
						goto yy481;
					} else {
						if (yych == 'u') goto yy481;
						goto yy223;
					}
				}
			}
		}
yy230:
		YYDEBUG(230, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych == 'N') goto yy472;
			if (yych <= 'R') goto yy284;
			goto yy473;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy284;
				goto yy472;
			} else {
				if (yych == 's') goto yy473;
				goto yy284;
			}
		}
yy231:
		YYDEBUG(231, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '_') goto yy398;
		goto yy284;
yy232:
		YYDEBUG(232, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy223;
		if (yych <= '=') goto yy392;
		if (yych <= '>') goto yy394;
		goto yy223;
yy233:
		YYDEBUG(233, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy388;
		if (yych == 'i') goto yy388;
		goto yy284;
yy234:
		YYDEBUG(234, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '+') goto yy386;
		if (yych == '=') goto yy384;
		goto yy223;
yy235:
		YYDEBUG(235, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy381;
		goto yy223;
yy236:
		YYDEBUG(236, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') {
			if (yych == '/') goto yy349;
			goto yy223;
		} else {
			if (yych <= '<') goto yy347;
			if (yych <= '=') goto yy350;
			if (yych <= '>') goto yy352;
			goto yy223;
		}
yy237:
		YYDEBUG(237, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy223;
		if (yych <= '=') goto yy343;
		if (yych <= '>') goto yy341;
		goto yy223;
yy238:
		YYDEBUG(238, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy339;
		goto yy223;
yy239:
		YYDEBUG(239, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '.') {
			if (yych == '*') goto yy330;
			goto yy223;
		} else {
			if (yych <= '/') goto yy332;
			if (yych == '=') goto yy333;
			goto yy223;
		}
yy240:
		YYDEBUG(240, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy223;
		if (yych <= '9') goto yy326;
		if (yych == '=') goto yy328;
		goto yy223;
yy241:
		YYDEBUG(241, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy223;
		if (yych <= '=') goto yy322;
		if (yych <= '>') goto yy320;
		goto yy223;
yy242:
		YYDEBUG(242, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '&') goto yy316;
		if (yych == '=') goto yy318;
		goto yy223;
yy243:
		YYDEBUG(243, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy314;
		if (yych == '|') goto yy312;
		goto yy223;
yy244:
		YYDEBUG(244, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy310;
		goto yy223;
yy245:
		YYDEBUG(245, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy308;
		if (yych == 'r') goto yy308;
		goto yy284;
yy246:
		YYDEBUG(246, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy305;
		if (yych == 'o') goto yy305;
		goto yy284;
yy247:
		YYDEBUG(247, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy223;
			if (yych <= 'Z') goto yy302;
			if (yych <= '^') goto yy223;
			goto yy302;
		} else {
			if (yych <= '`') goto yy223;
			if (yych <= 'z') goto yy302;
			if (yych <= '~') goto yy223;
			goto yy302;
		}
yy248:
		YYDEBUG(248, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy223;
yy249:
		YYDEBUG(249, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy298;
		goto yy223;
yy250:
		YYDEBUG(250, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(251, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1343 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return '{';
}
#line 3789 "Zend/zend_language_scanner.c"
yy252:
		YYDEBUG(252, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(253, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1355 "Zend/zend_language_scanner.l"
		{
	RESET_DOC_COMMENT();
	if (!zend_stack_is_empty(&SCNG(state_stack))) {
		yy_pop_state(TSRMLS_C);
	}
	return '}';
}
#line 3803 "Zend/zend_language_scanner.c"
yy254:
		YYDEBUG(254, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') {
				if (yych == '.') goto yy285;
			} else {
				if (yych <= '9') goto yy288;
				if (yych >= 'E') goto yy290;
			}
		} else {
			if (yych <= 'd') {
				if (yych == 'X') goto yy294;
			} else {
				if (yych <= 'e') goto yy290;
				if (yych == 'x') goto yy294;
			}
		}
yy255:
		YYDEBUG(255, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1381 "Zend/zend_language_scanner.l"
		{
	if (yyleng < MAX_LENGTH_OF_LONG - 1) { /* Won't overflow */
		zendlval->value.lval = strtol(yytext, NULL, 0);
	} else {
		errno = 0;
		zendlval->value.lval = strtol(yytext, NULL, 0);
		if (errno == ERANGE) { /* Overflow */
			if (yytext[0] == '0') { /* octal overflow */
				zendlval->value.dval = zend_oct_strtod(yytext, NULL);
			} else {
				zendlval->value.dval = zend_strtod(yytext, NULL);
			}
			zendlval->type = IS_DOUBLE;
			return T_DNUMBER;
		}
	}

	zendlval->type = IS_LONG;
	return T_LNUMBER;
}
#line 3847 "Zend/zend_language_scanner.c"
yy256:
		YYDEBUG(256, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '9') {
			if (yych == '.') goto yy285;
			if (yych <= '/') goto yy255;
			goto yy288;
		} else {
			if (yych <= 'E') {
				if (yych <= 'D') goto yy255;
				goto yy290;
			} else {
				if (yych == 'e') goto yy290;
				goto yy255;
			}
		}
yy257:
		YYDEBUG(257, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy284;
yy258:
		YYDEBUG(258, *YYCURSOR);
		++YYCURSOR;
yy259:
		YYDEBUG(259, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1726 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_ONE_LINE_COMMENT);
	yymore();
}
#line 3880 "Zend/zend_language_scanner.c"
yy260:
		YYDEBUG(260, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy276;
yy261:
		YYDEBUG(261, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1893 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_DOUBLE_QUOTES);
	return '"';
}
#line 3894 "Zend/zend_language_scanner.c"
yy262:
		YYDEBUG(262, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy268;
yy263:
		YYDEBUG(263, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2179 "Zend/zend_language_scanner.l"
		{
	zend_error(E_COMPILE_WARNING,"Unexpected character in input:  '%c' (ASCII=%d) state=%d", yytext[0], yytext[0], YYSTATE);
	goto restart;
}
#line 3908 "Zend/zend_language_scanner.c"
yy264:
		YYDEBUG(264, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(265, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1921 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_BACKQUOTE);
	return '`';
}
#line 3919 "Zend/zend_language_scanner.c"
yy266:
		YYDEBUG(266, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy263;
yy267:
		YYDEBUG(267, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy268:
		YYDEBUG(268, *YYCURSOR);
		if (yybm[256+yych] & 128) {
			goto yy267;
		}
		if (yych <= '[') goto yy270;
		YYDEBUG(269, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		goto yy267;
yy270:
		YYDEBUG(270, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(271, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1842 "Zend/zend_language_scanner.l"
		{
	register char *s, *t;
	char *end;
	int bprefix = (yytext[0] != '\'') ? 1 : 0;

	zendlval->value.str.val = estrndup(yytext+bprefix+1, yyleng-bprefix-2);
	zendlval->value.str.len = yyleng-bprefix-2;
	zendlval->type = IS_STRING;

	/* convert escape sequences */
	s = t = zendlval->value.str.val;
	end = s+zendlval->value.str.len;
	while (s<end) {
		if (*s=='\\') {
			s++;

			switch(*s) {
				case '\\':
				case '\'':
					*t++ = *s;
					zendlval->value.str.len--;
					break;
				default:
					*t++ = '\\';
					*t++ = *s;
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;

#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		size_t sz = 0;
		s = zendlval->value.str.val;
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)s, (size_t)zendlval->value.str.len TSRMLS_CC);
		zendlval->value.str.len = sz;
		efree(s);
	}
#endif /* ZEND_MULTIBYTE */
	return T_CONSTANT_ENCAPSED_STRING;
}
#line 3995 "Zend/zend_language_scanner.c"
yy272:
		YYDEBUG(272, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(273, *YYCURSOR);
		if (yybm[0+yych] & 2) {
			goto yy275;
		}
		if (yych <= '#') goto yy280;
		if (yych <= '$') goto yy274;
		if (yych <= 'z') goto yy277;
		goto yy272;
yy274:
		YYDEBUG(274, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 3) {
			if (yyaccept <= 1) {
				if (yyaccept <= 0) {
					goto yy209;
				} else {
					goto yy223;
				}
			} else {
				if (yyaccept <= 2) {
					goto yy255;
				} else {
					goto yy261;
				}
			}
		} else {
			if (yyaccept <= 5) {
				if (yyaccept <= 4) {
					goto yy263;
				} else {
					goto yy287;
				}
			} else {
				if (yyaccept <= 6) {
					goto yy331;
				} else {
					goto yy348;
				}
			}
		}
yy275:
		YYDEBUG(275, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy276:
		YYDEBUG(276, *YYCURSOR);
		if (yybm[0+yych] & 2) {
			goto yy275;
		}
		if (yych <= '#') goto yy280;
		if (yych <= '$') goto yy278;
		if (yych >= '{') goto yy272;
yy277:
		YYDEBUG(277, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		goto yy275;
yy278:
		YYDEBUG(278, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(279, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy278;
		}
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych != '"') goto yy275;
			} else {
				if (yych <= 'Z') goto yy274;
				if (yych <= '[') goto yy275;
				goto yy282;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy274;
				goto yy275;
			} else {
				if (yych <= '{') goto yy274;
				if (yych <= '~') goto yy275;
				goto yy274;
			}
		}
yy280:
		YYDEBUG(280, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(281, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1834 "Zend/zend_language_scanner.l"
		{
	int bprefix = (yytext[0] != '"') ? 1 : 0;

	zend_scan_escape_string(zendlval, yytext+bprefix+1, yyleng-bprefix-2, '"' TSRMLS_CC);
	return T_CONSTANT_ENCAPSED_STRING;
}
#line 4099 "Zend/zend_language_scanner.c"
yy282:
		YYDEBUG(282, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		goto yy275;
yy283:
		YYDEBUG(283, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy284:
		YYDEBUG(284, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy283;
		}
		goto yy209;
yy285:
		YYDEBUG(285, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(286, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy285;
		}
		if (yych == 'E') goto yy290;
		if (yych == 'e') goto yy290;
yy287:
		YYDEBUG(287, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1442 "Zend/zend_language_scanner.l"
		{
	zendlval->value.dval = zend_strtod(yytext, NULL);
	zendlval->type = IS_DOUBLE;
	return T_DNUMBER;
}
#line 4138 "Zend/zend_language_scanner.c"
yy288:
		YYDEBUG(288, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(289, *YYCURSOR);
		if (yych <= '9') {
			if (yych == '.') goto yy285;
			if (yych <= '/') goto yy255;
			goto yy288;
		} else {
			if (yych <= 'E') {
				if (yych <= 'D') goto yy255;
			} else {
				if (yych != 'e') goto yy255;
			}
		}
yy290:
		YYDEBUG(290, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ',') {
			if (yych != '+') goto yy274;
		} else {
			if (yych <= '-') goto yy291;
			if (yych <= '/') goto yy274;
			if (yych <= '9') goto yy292;
			goto yy274;
		}
yy291:
		YYDEBUG(291, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy274;
		if (yych >= ':') goto yy274;
yy292:
		YYDEBUG(292, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(293, *YYCURSOR);
		if (yych <= '/') goto yy287;
		if (yych <= '9') goto yy292;
		goto yy287;
yy294:
		YYDEBUG(294, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy295;
		}
		goto yy274;
yy295:
		YYDEBUG(295, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(296, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy295;
		}
		YYDEBUG(297, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1402 "Zend/zend_language_scanner.l"
		{
	char *hex = yytext + 2; /* Skip "0x" */
	int len = yyleng - 2;

	/* Skip any leading 0s */
	while (*hex == '0') {
		hex++;
		len--;
	}

	if (len < SIZEOF_LONG * 2 || (len == SIZEOF_LONG * 2 && *hex <= '7')) {
		zendlval->value.lval = strtol(hex, NULL, 16);
		zendlval->type = IS_LONG;
		return T_LNUMBER;
	} else {
		zendlval->value.dval = zend_hex_strtod(hex, NULL);
		zendlval->type = IS_DOUBLE;
		return T_DNUMBER;
	}
}
#line 4221 "Zend/zend_language_scanner.c"
yy298:
		YYDEBUG(298, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy300;
		if (yych == '\r') goto yy301;
yy299:
		YYDEBUG(299, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1809 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(INITIAL);
	return T_CLOSE_TAG;  /* implicit ';' at php-end tag */
}
#line 4238 "Zend/zend_language_scanner.c"
yy300:
		YYDEBUG(300, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy299;
yy301:
		YYDEBUG(301, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy300;
		goto yy299;
yy302:
		YYDEBUG(302, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(303, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy302;
			} else {
				if (yych <= '@') goto yy304;
				if (yych <= 'Z') goto yy302;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy302;
			} else {
				if (yych <= 'z') goto yy302;
				if (yych >= 0x7F) goto yy302;
			}
		}
yy304:
		YYDEBUG(304, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1695 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 4278 "Zend/zend_language_scanner.c"
yy305:
		YYDEBUG(305, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy306;
		if (yych != 'r') goto yy284;
yy306:
		YYDEBUG(306, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(307, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1326 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_XOR;
}
#line 4296 "Zend/zend_language_scanner.c"
yy308:
		YYDEBUG(308, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(309, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1318 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_OR;
}
#line 4309 "Zend/zend_language_scanner.c"
yy310:
		YYDEBUG(310, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(311, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1306 "Zend/zend_language_scanner.l"
		{
	return T_XOR_EQUAL;
}
#line 4319 "Zend/zend_language_scanner.c"
yy312:
		YYDEBUG(312, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(313, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1310 "Zend/zend_language_scanner.l"
		{
	return T_BOOLEAN_OR;
}
#line 4329 "Zend/zend_language_scanner.c"
yy314:
		YYDEBUG(314, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(315, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1302 "Zend/zend_language_scanner.l"
		{
	return T_OR_EQUAL;
}
#line 4339 "Zend/zend_language_scanner.c"
yy316:
		YYDEBUG(316, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(317, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1314 "Zend/zend_language_scanner.l"
		{
	return T_BOOLEAN_AND;
}
#line 4349 "Zend/zend_language_scanner.c"
yy318:
		YYDEBUG(318, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(319, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1298 "Zend/zend_language_scanner.l"
		{
	return T_AND_EQUAL;
}
#line 4359 "Zend/zend_language_scanner.c"
yy320:
		YYDEBUG(320, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy324;
		if (yych == '\r') goto yy325;
yy321:
		YYDEBUG(321, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1818 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		BEGIN(INITIAL);
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		zendlval->value.str.val = yytext; /* no copying - intentional */
		return T_CLOSE_TAG;  /* implicit ';' at php-end tag */
	} else {
		yyless(1);
		return yytext[0];
	}
}
#line 4381 "Zend/zend_language_scanner.c"
yy322:
		YYDEBUG(322, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(323, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1286 "Zend/zend_language_scanner.l"
		{
	return T_MOD_EQUAL;
}
#line 4391 "Zend/zend_language_scanner.c"
yy324:
		YYDEBUG(324, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy321;
yy325:
		YYDEBUG(325, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy324;
		goto yy321;
yy326:
		YYDEBUG(326, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(327, *YYCURSOR);
		if (yych <= 'D') {
			if (yych <= '/') goto yy287;
			if (yych <= '9') goto yy326;
			goto yy287;
		} else {
			if (yych <= 'E') goto yy290;
			if (yych == 'e') goto yy290;
			goto yy287;
		}
yy328:
		YYDEBUG(328, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(329, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1282 "Zend/zend_language_scanner.l"
		{
	return T_CONCAT_EQUAL;
}
#line 4426 "Zend/zend_language_scanner.c"
yy330:
		YYDEBUG(330, *YYCURSOR);
		yyaccept = 6;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '*') goto yy335;
yy331:
		YYDEBUG(331, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1781 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_COMMENT);
	yymore();
}
#line 4440 "Zend/zend_language_scanner.c"
yy332:
		YYDEBUG(332, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy259;
yy333:
		YYDEBUG(333, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(334, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1278 "Zend/zend_language_scanner.l"
		{
	return T_DIV_EQUAL;
}
#line 4454 "Zend/zend_language_scanner.c"
yy335:
		YYDEBUG(335, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy336;
		}
		goto yy274;
yy336:
		YYDEBUG(336, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(337, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy336;
		}
		YYDEBUG(338, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1775 "Zend/zend_language_scanner.l"
		{
	RESET_DOC_COMMENT();
	BEGIN(ST_DOC_COMMENT);
	yymore();
}
#line 4479 "Zend/zend_language_scanner.c"
yy339:
		YYDEBUG(339, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(340, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1274 "Zend/zend_language_scanner.l"
		{
	return T_MUL_EQUAL;
}
#line 4489 "Zend/zend_language_scanner.c"
yy341:
		YYDEBUG(341, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy345;
		YYDEBUG(342, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1334 "Zend/zend_language_scanner.l"
		{
	return T_SR;
}
#line 4500 "Zend/zend_language_scanner.c"
yy343:
		YYDEBUG(343, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(344, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1262 "Zend/zend_language_scanner.l"
		{
	return T_IS_GREATER_OR_EQUAL;
}
#line 4510 "Zend/zend_language_scanner.c"
yy345:
		YYDEBUG(345, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(346, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1294 "Zend/zend_language_scanner.l"
		{
	return T_SR_EQUAL;
}
#line 4520 "Zend/zend_language_scanner.c"
yy347:
		YYDEBUG(347, *YYCURSOR);
		yyaccept = 7;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') goto yy348;
		if (yych <= '<') goto yy363;
		if (yych <= '=') goto yy361;
yy348:
		YYDEBUG(348, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1330 "Zend/zend_language_scanner.l"
		{
	return T_SL;
}
#line 4535 "Zend/zend_language_scanner.c"
yy349:
		YYDEBUG(349, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy354;
		if (yych == 's') goto yy354;
		goto yy274;
yy350:
		YYDEBUG(350, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(351, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1258 "Zend/zend_language_scanner.l"
		{
	return T_IS_SMALLER_OR_EQUAL;
}
#line 4551 "Zend/zend_language_scanner.c"
yy352:
		YYDEBUG(352, *YYCURSOR);
		++YYCURSOR;
yy353:
		YYDEBUG(353, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1254 "Zend/zend_language_scanner.l"
		{
	return T_IS_NOT_EQUAL;
}
#line 4562 "Zend/zend_language_scanner.c"
yy354:
		YYDEBUG(354, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy355;
		if (yych != 'c') goto yy274;
yy355:
		YYDEBUG(355, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy356;
		if (yych != 'r') goto yy274;
yy356:
		YYDEBUG(356, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy357;
		if (yych != 'i') goto yy274;
yy357:
		YYDEBUG(357, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy358;
		if (yych != 'p') goto yy274;
yy358:
		YYDEBUG(358, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy359;
		if (yych != 't') goto yy274;
yy359:
		YYDEBUG(359, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(360, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy274;
			if (yych <= '\n') goto yy359;
			if (yych <= '\f') goto yy274;
			goto yy359;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy274;
				goto yy359;
			} else {
				if (yych == '>') goto yy298;
				goto yy274;
			}
		}
yy361:
		YYDEBUG(361, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(362, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1290 "Zend/zend_language_scanner.l"
		{
	return T_SL_EQUAL;
}
#line 4617 "Zend/zend_language_scanner.c"
yy363:
		YYDEBUG(363, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(364, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy363;
		}
		if (yych <= 'Z') {
			if (yych <= '&') {
				if (yych == '"') goto yy368;
				goto yy274;
			} else {
				if (yych <= '\'') goto yy365;
				if (yych <= '@') goto yy274;
				goto yy366;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy366;
				goto yy274;
			} else {
				if (yych <= 'z') goto yy366;
				if (yych <= '~') goto yy274;
				goto yy366;
			}
		}
yy365:
		YYDEBUG(365, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\'') goto yy274;
		if (yych <= '/') goto yy376;
		if (yych <= '9') goto yy274;
		goto yy376;
yy366:
		YYDEBUG(366, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(367, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\f') {
				if (yych == '\n') goto yy372;
				goto yy274;
			} else {
				if (yych <= '\r') goto yy374;
				if (yych <= '/') goto yy274;
				if (yych <= '9') goto yy366;
				goto yy274;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy366;
				if (yych <= '^') goto yy274;
				goto yy366;
			} else {
				if (yych <= '`') goto yy274;
				if (yych <= 'z') goto yy366;
				if (yych <= '~') goto yy274;
				goto yy366;
			}
		}
yy368:
		YYDEBUG(368, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy274;
		if (yych <= '/') goto yy370;
		if (yych <= '9') goto yy274;
		goto yy370;
yy369:
		YYDEBUG(369, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy370:
		YYDEBUG(370, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych != '"') goto yy274;
			} else {
				if (yych <= '9') goto yy369;
				if (yych <= '@') goto yy274;
				goto yy369;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy369;
				goto yy274;
			} else {
				if (yych <= 'z') goto yy369;
				if (yych <= '~') goto yy274;
				goto yy369;
			}
		}
		YYDEBUG(371, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy372;
		if (yych == '\r') goto yy374;
		goto yy274;
yy372:
		YYDEBUG(372, *YYCURSOR);
		++YYCURSOR;
yy373:
		YYDEBUG(373, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1899 "Zend/zend_language_scanner.l"
		{
	char *s;
	int bprefix = (yytext[0] != '<') ? 1 : 0;

	CG(zend_lineno)++;
	CG(heredoc_len) = yyleng-bprefix-3-1-(yytext[yyleng-2]=='\r'?1:0);
	s = yytext+bprefix+3;
	while ((*s == ' ') || (*s == '\t')) {
		s++;
		CG(heredoc_len)--;
	}

	if (*s == '"') {
		s++;
		CG(heredoc_len) -= 2;
	}
	CG(heredoc) = estrndup(s, CG(heredoc_len));
	BEGIN(ST_START_HEREDOC);
	return T_START_HEREDOC;
}
#line 4745 "Zend/zend_language_scanner.c"
yy374:
		YYDEBUG(374, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy372;
		goto yy373;
yy375:
		YYDEBUG(375, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy376:
		YYDEBUG(376, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych != '\'') goto yy274;
			} else {
				if (yych <= '9') goto yy375;
				if (yych <= '@') goto yy274;
				goto yy375;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy375;
				goto yy274;
			} else {
				if (yych <= 'z') goto yy375;
				if (yych <= '~') goto yy274;
				goto yy375;
			}
		}
		YYDEBUG(377, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy378;
		if (yych == '\r') goto yy380;
		goto yy274;
yy378:
		YYDEBUG(378, *YYCURSOR);
		++YYCURSOR;
yy379:
		YYDEBUG(379, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2070 "Zend/zend_language_scanner.l"
		{
	int bprefix = (yytext[0] != '<') ? 1 : 0;
	char *s;
	CG(zend_lineno)++;
	/* 3 is <<<, 2 is quotes, 1 is newline */
	CG(heredoc_len) = yyleng-bprefix-3-2-1-(yytext[yyleng-2]=='\r'?1:0);
	s = yytext+bprefix+3;
	while ((*s == ' ') || (*s == '\t')) {
		s++;
		CG(heredoc_len)--;
	}
	s++; /* first quote */
	CG(heredoc) = estrndup(s, CG(heredoc_len));
	BEGIN(ST_START_NOWDOC);
	return T_START_NOWDOC;
}
#line 4804 "Zend/zend_language_scanner.c"
yy380:
		YYDEBUG(380, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy378;
		goto yy379;
yy381:
		YYDEBUG(381, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '=') goto yy353;
		YYDEBUG(382, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(383, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1246 "Zend/zend_language_scanner.l"
		{
	return T_IS_NOT_IDENTICAL;
}
#line 4822 "Zend/zend_language_scanner.c"
yy384:
		YYDEBUG(384, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(385, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1266 "Zend/zend_language_scanner.l"
		{
	return T_PLUS_EQUAL;
}
#line 4832 "Zend/zend_language_scanner.c"
yy386:
		YYDEBUG(386, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(387, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1234 "Zend/zend_language_scanner.l"
		{
	return T_INC;
}
#line 4842 "Zend/zend_language_scanner.c"
yy388:
		YYDEBUG(388, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy389;
		if (yych != 's') goto yy284;
yy389:
		YYDEBUG(389, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy390;
		if (yych != 't') goto yy284;
yy390:
		YYDEBUG(390, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(391, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1226 "Zend/zend_language_scanner.l"
		{
	return T_LIST;
}
#line 4865 "Zend/zend_language_scanner.c"
yy392:
		YYDEBUG(392, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy396;
		YYDEBUG(393, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1250 "Zend/zend_language_scanner.l"
		{
	return T_IS_EQUAL;
}
#line 4876 "Zend/zend_language_scanner.c"
yy394:
		YYDEBUG(394, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(395, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1222 "Zend/zend_language_scanner.l"
		{
	return T_DOUBLE_ARROW;
}
#line 4886 "Zend/zend_language_scanner.c"
yy396:
		YYDEBUG(396, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(397, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1242 "Zend/zend_language_scanner.l"
		{
	return T_IS_IDENTICAL;
}
#line 4896 "Zend/zend_language_scanner.c"
yy398:
		YYDEBUG(398, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'H') {
			if (yych <= 'D') {
				if (yych <= 'B') goto yy284;
				if (yych <= 'C') goto yy400;
				goto yy404;
			} else {
				if (yych == 'F') goto yy401;
				if (yych <= 'G') goto yy284;
			}
		} else {
			if (yych <= 'M') {
				if (yych <= 'K') goto yy284;
				if (yych <= 'L') goto yy403;
				goto yy402;
			} else {
				if (yych <= 'N') goto yy405;
				if (yych != 'h') goto yy284;
			}
		}
		YYDEBUG(399, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy459;
		if (yych == 'a') goto yy459;
		goto yy284;
yy400:
		YYDEBUG(400, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy452;
		goto yy284;
yy401:
		YYDEBUG(401, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy436;
		if (yych == 'U') goto yy437;
		goto yy284;
yy402:
		YYDEBUG(402, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy428;
		goto yy284;
yy403:
		YYDEBUG(403, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy422;
		goto yy284;
yy404:
		YYDEBUG(404, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy417;
		goto yy284;
yy405:
		YYDEBUG(405, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'A') goto yy284;
		YYDEBUG(406, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'M') goto yy284;
		YYDEBUG(407, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'E') goto yy284;
		YYDEBUG(408, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'S') goto yy284;
		YYDEBUG(409, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'P') goto yy284;
		YYDEBUG(410, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'A') goto yy284;
		YYDEBUG(411, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'C') goto yy284;
		YYDEBUG(412, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'E') goto yy284;
		YYDEBUG(413, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(414, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(415, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(416, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1546 "Zend/zend_language_scanner.l"
		{
	if (CG(current_namespace)) {
		*zendlval = *CG(current_namespace);
		zval_copy_ctor(zendlval);
	} else {
		ZVAL_EMPTY_STRING(zendlval);
	}
	return T_NS_C;
}
#line 4998 "Zend/zend_language_scanner.c"
yy417:
		YYDEBUG(417, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'R') goto yy284;
		YYDEBUG(418, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(419, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(420, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(421, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1519 "Zend/zend_language_scanner.l"
		{
	char *filename = zend_get_compiled_filename(TSRMLS_C);
	const size_t filename_len = strlen(filename);
	char *dirname;

	if (!filename) {
		filename = "";
	}

	dirname = estrndup(filename, filename_len);
	zend_dirname(dirname, filename_len);

	if (strcmp(dirname, ".") == 0) {
		dirname = erealloc(dirname, MAXPATHLEN);
#if HAVE_GETCWD
		VCWD_GETCWD(dirname, MAXPATHLEN);
#elif HAVE_GETWD
		VCWD_GETWD(dirname);
#endif
	}

	zendlval->value.str.len = strlen(dirname);
	zendlval->value.str.val = dirname;
	zendlval->type = IS_STRING;
	return T_DIR;
}
#line 5043 "Zend/zend_language_scanner.c"
yy422:
		YYDEBUG(422, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'N') goto yy284;
		YYDEBUG(423, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'E') goto yy284;
		YYDEBUG(424, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(425, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(426, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(427, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1501 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = CG(zend_lineno);
	zendlval->type = IS_LONG;
	return T_LINE;
}
#line 5070 "Zend/zend_language_scanner.c"
yy428:
		YYDEBUG(428, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'T') goto yy284;
		YYDEBUG(429, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'H') goto yy284;
		YYDEBUG(430, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'O') goto yy284;
		YYDEBUG(431, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'D') goto yy284;
		YYDEBUG(432, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(433, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(434, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(435, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1480 "Zend/zend_language_scanner.l"
		{
	char *class_name = CG(active_class_entry) ? CG(active_class_entry)->name : NULL;
	char *func_name = CG(active_op_array)? CG(active_op_array)->function_name : NULL;
	size_t len = 0;

	if (class_name) {
		len += strlen(class_name) + 2;
	}
	if (func_name) {
		len += strlen(func_name);
	}

	zendlval->value.str.len = zend_spprintf(&zendlval->value.str.val, 0, "%s%s%s", 
		class_name ? class_name : "",
		class_name && func_name ? "::" : "",
		func_name ? func_name : ""
		);
	zendlval->type = IS_STRING;
	return T_METHOD_C;
}
#line 5118 "Zend/zend_language_scanner.c"
yy436:
		YYDEBUG(436, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy447;
		goto yy284;
yy437:
		YYDEBUG(437, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'N') goto yy284;
		YYDEBUG(438, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'C') goto yy284;
		YYDEBUG(439, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'T') goto yy284;
		YYDEBUG(440, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'I') goto yy284;
		YYDEBUG(441, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'O') goto yy284;
		YYDEBUG(442, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'N') goto yy284;
		YYDEBUG(443, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(444, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(445, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(446, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1464 "Zend/zend_language_scanner.l"
		{
	char *func_name = NULL;

	if (CG(active_op_array)) {
		func_name = CG(active_op_array)->function_name;
	}

	if (!func_name) {
		func_name = "";
	}
	zendlval->value.str.len = strlen(func_name);
	zendlval->value.str.val = estrndup(func_name, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_FUNC_C;
}
#line 5172 "Zend/zend_language_scanner.c"
yy447:
		YYDEBUG(447, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'E') goto yy284;
		YYDEBUG(448, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(449, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(450, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(451, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1507 "Zend/zend_language_scanner.l"
		{
	char *filename = zend_get_compiled_filename(TSRMLS_C);

	if (!filename) {
		filename = "";
	}
	zendlval->value.str.len = strlen(filename);
	zendlval->value.str.val = estrndup(filename, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_FILE;
}
#line 5202 "Zend/zend_language_scanner.c"
yy452:
		YYDEBUG(452, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'A') goto yy284;
		YYDEBUG(453, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'S') goto yy284;
		YYDEBUG(454, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != 'S') goto yy284;
		YYDEBUG(455, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(456, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(457, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(458, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1448 "Zend/zend_language_scanner.l"
		{
	char *class_name = NULL;

	if (CG(active_class_entry)) {
		class_name = CG(active_class_entry)->name;
	}

	if (!class_name) {
		class_name = "";
	}
	zendlval->value.str.len = strlen(class_name);
	zendlval->value.str.val = estrndup(class_name, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_CLASS_C;
}
#line 5242 "Zend/zend_language_scanner.c"
yy459:
		YYDEBUG(459, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy460;
		if (yych != 'l') goto yy284;
yy460:
		YYDEBUG(460, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy461;
		if (yych != 't') goto yy284;
yy461:
		YYDEBUG(461, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy284;
		YYDEBUG(462, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy463;
		if (yych != 'c') goto yy284;
yy463:
		YYDEBUG(463, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy464;
		if (yych != 'o') goto yy284;
yy464:
		YYDEBUG(464, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy465;
		if (yych != 'm') goto yy284;
yy465:
		YYDEBUG(465, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy466;
		if (yych != 'p') goto yy284;
yy466:
		YYDEBUG(466, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy467;
		if (yych != 'i') goto yy284;
yy467:
		YYDEBUG(467, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy468;
		if (yych != 'l') goto yy284;
yy468:
		YYDEBUG(468, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy469;
		if (yych != 'e') goto yy284;
yy469:
		YYDEBUG(469, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy470;
		if (yych != 'r') goto yy284;
yy470:
		YYDEBUG(470, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(471, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1190 "Zend/zend_language_scanner.l"
		{
	return T_HALT_COMPILER;
}
#line 5308 "Zend/zend_language_scanner.c"
yy472:
		YYDEBUG(472, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy476;
		if (yych == 's') goto yy476;
		goto yy284;
yy473:
		YYDEBUG(473, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy474;
		if (yych != 'e') goto yy284;
yy474:
		YYDEBUG(474, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(475, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1174 "Zend/zend_language_scanner.l"
		{
	return T_USE;
}
#line 5332 "Zend/zend_language_scanner.c"
yy476:
		YYDEBUG(476, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy477;
		if (yych != 'e') goto yy284;
yy477:
		YYDEBUG(477, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy478;
		if (yych != 't') goto yy284;
yy478:
		YYDEBUG(478, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(479, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1218 "Zend/zend_language_scanner.l"
		{
	return T_UNSET;
}
#line 5355 "Zend/zend_language_scanner.c"
yy480:
		YYDEBUG(480, *YYCURSOR);
		++YYCURSOR;
		YYFILL(7);
		yych = *YYCURSOR;
yy481:
		YYDEBUG(481, *YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy480;
					if (yych <= 0x1F) goto yy274;
					goto yy480;
				} else {
					if (yych <= 'A') {
						if (yych <= '@') goto yy274;
						goto yy485;
					} else {
						if (yych <= 'B') goto yy483;
						if (yych <= 'C') goto yy274;
						goto yy488;
					}
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy489;
					if (yych <= 'H') goto yy274;
					goto yy490;
				} else {
					if (yych <= 'O') {
						if (yych <= 'N') goto yy274;
						goto yy484;
					} else {
						if (yych <= 'Q') goto yy274;
						if (yych <= 'R') goto yy487;
						goto yy486;
					}
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'a') {
					if (yych == 'U') goto yy482;
					if (yych <= '`') goto yy274;
					goto yy485;
				} else {
					if (yych <= 'c') {
						if (yych <= 'b') goto yy483;
						goto yy274;
					} else {
						if (yych <= 'd') goto yy488;
						if (yych <= 'e') goto yy274;
						goto yy489;
					}
				}
			} else {
				if (yych <= 'q') {
					if (yych <= 'i') {
						if (yych <= 'h') goto yy274;
						goto yy490;
					} else {
						if (yych == 'o') goto yy484;
						goto yy274;
					}
				} else {
					if (yych <= 's') {
						if (yych <= 'r') goto yy487;
						goto yy486;
					} else {
						if (yych != 'u') goto yy274;
					}
				}
			}
		}
yy482:
		YYDEBUG(482, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy553;
		if (yych == 'n') goto yy553;
		goto yy274;
yy483:
		YYDEBUG(483, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy536;
			if (yych <= 'N') goto yy274;
			goto yy537;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy274;
				goto yy536;
			} else {
				if (yych == 'o') goto yy537;
				goto yy274;
			}
		}
yy484:
		YYDEBUG(484, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy528;
		if (yych == 'b') goto yy528;
		goto yy274;
yy485:
		YYDEBUG(485, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy521;
		if (yych == 'r') goto yy521;
		goto yy274;
yy486:
		YYDEBUG(486, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy513;
		if (yych == 't') goto yy513;
		goto yy274;
yy487:
		YYDEBUG(487, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy511;
		if (yych == 'e') goto yy511;
		goto yy274;
yy488:
		YYDEBUG(488, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy507;
		if (yych == 'o') goto yy507;
		goto yy274;
yy489:
		YYDEBUG(489, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy500;
		if (yych == 'l') goto yy500;
		goto yy274;
yy490:
		YYDEBUG(490, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy491;
		if (yych != 'n') goto yy274;
yy491:
		YYDEBUG(491, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy492;
		if (yych != 't') goto yy274;
yy492:
		YYDEBUG(492, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy493;
		if (yych != 'e') goto yy495;
yy493:
		YYDEBUG(493, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy498;
		if (yych == 'g') goto yy498;
		goto yy274;
yy494:
		YYDEBUG(494, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy495:
		YYDEBUG(495, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy494;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy494;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(496, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(497, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1118 "Zend/zend_language_scanner.l"
		{
	return T_INT_CAST;
}
#line 5531 "Zend/zend_language_scanner.c"
yy498:
		YYDEBUG(498, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy499;
		if (yych != 'e') goto yy274;
yy499:
		YYDEBUG(499, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy494;
		if (yych == 'r') goto yy494;
		goto yy274;
yy500:
		YYDEBUG(500, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy501;
		if (yych != 'o') goto yy274;
yy501:
		YYDEBUG(501, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy502;
		if (yych != 'a') goto yy274;
yy502:
		YYDEBUG(502, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy503;
		if (yych != 't') goto yy274;
yy503:
		YYDEBUG(503, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(504, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy503;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy503;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(505, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(506, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1122 "Zend/zend_language_scanner.l"
		{
	return T_DOUBLE_CAST;
}
#line 5579 "Zend/zend_language_scanner.c"
yy507:
		YYDEBUG(507, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy508;
		if (yych != 'u') goto yy274;
yy508:
		YYDEBUG(508, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy509;
		if (yych != 'b') goto yy274;
yy509:
		YYDEBUG(509, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy510;
		if (yych != 'l') goto yy274;
yy510:
		YYDEBUG(510, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy503;
		if (yych == 'e') goto yy503;
		goto yy274;
yy511:
		YYDEBUG(511, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy512;
		if (yych != 'a') goto yy274;
yy512:
		YYDEBUG(512, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy503;
		if (yych == 'l') goto yy503;
		goto yy274;
yy513:
		YYDEBUG(513, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy514;
		if (yych != 'r') goto yy274;
yy514:
		YYDEBUG(514, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy515;
		if (yych != 'i') goto yy274;
yy515:
		YYDEBUG(515, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy516;
		if (yych != 'n') goto yy274;
yy516:
		YYDEBUG(516, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy517;
		if (yych != 'g') goto yy274;
yy517:
		YYDEBUG(517, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(518, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy517;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy517;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(519, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(520, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1126 "Zend/zend_language_scanner.l"
		{
	return T_STRING_CAST;
}
#line 5653 "Zend/zend_language_scanner.c"
yy521:
		YYDEBUG(521, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy522;
		if (yych != 'r') goto yy274;
yy522:
		YYDEBUG(522, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy523;
		if (yych != 'a') goto yy274;
yy523:
		YYDEBUG(523, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy524;
		if (yych != 'y') goto yy274;
yy524:
		YYDEBUG(524, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(525, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy524;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy524;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(526, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(527, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1134 "Zend/zend_language_scanner.l"
		{
	return T_ARRAY_CAST;
}
#line 5690 "Zend/zend_language_scanner.c"
yy528:
		YYDEBUG(528, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'J') goto yy529;
		if (yych != 'j') goto yy274;
yy529:
		YYDEBUG(529, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy530;
		if (yych != 'e') goto yy274;
yy530:
		YYDEBUG(530, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy531;
		if (yych != 'c') goto yy274;
yy531:
		YYDEBUG(531, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy532;
		if (yych != 't') goto yy274;
yy532:
		YYDEBUG(532, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(533, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy532;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy532;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(534, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(535, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1138 "Zend/zend_language_scanner.l"
		{
	return T_OBJECT_CAST;
}
#line 5732 "Zend/zend_language_scanner.c"
yy536:
		YYDEBUG(536, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy546;
		if (yych == 'n') goto yy546;
		goto yy274;
yy537:
		YYDEBUG(537, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy538;
		if (yych != 'o') goto yy274;
yy538:
		YYDEBUG(538, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy539;
		if (yych != 'l') goto yy274;
yy539:
		YYDEBUG(539, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy544;
		if (yych == 'e') goto yy544;
		goto yy541;
yy540:
		YYDEBUG(540, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy541:
		YYDEBUG(541, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy540;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy540;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(542, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(543, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1142 "Zend/zend_language_scanner.l"
		{
	return T_BOOL_CAST;
}
#line 5777 "Zend/zend_language_scanner.c"
yy544:
		YYDEBUG(544, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy545;
		if (yych != 'a') goto yy274;
yy545:
		YYDEBUG(545, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy540;
		if (yych == 'n') goto yy540;
		goto yy274;
yy546:
		YYDEBUG(546, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy547;
		if (yych != 'a') goto yy274;
yy547:
		YYDEBUG(547, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy548;
		if (yych != 'r') goto yy274;
yy548:
		YYDEBUG(548, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy549;
		if (yych != 'y') goto yy274;
yy549:
		YYDEBUG(549, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(550, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy549;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy549;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(551, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(552, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1130 "Zend/zend_language_scanner.l"
		{
	return T_STRING_CAST;
}
#line 5825 "Zend/zend_language_scanner.c"
yy553:
		YYDEBUG(553, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy554;
		if (yych != 's') goto yy274;
yy554:
		YYDEBUG(554, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy555;
		if (yych != 'e') goto yy274;
yy555:
		YYDEBUG(555, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy556;
		if (yych != 't') goto yy274;
yy556:
		YYDEBUG(556, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(557, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy556;
			goto yy274;
		} else {
			if (yych <= ' ') goto yy556;
			if (yych != ')') goto yy274;
		}
		YYDEBUG(558, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(559, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1146 "Zend/zend_language_scanner.l"
		{
	return T_UNSET_CAST;
}
#line 5862 "Zend/zend_language_scanner.c"
yy560:
		YYDEBUG(560, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy561;
		if (yych != 'r') goto yy284;
yy561:
		YYDEBUG(561, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(562, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1114 "Zend/zend_language_scanner.l"
		{
	return T_VAR;
}
#line 5880 "Zend/zend_language_scanner.c"
yy563:
		YYDEBUG(563, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy567;
		if (yych == 'm') goto yy567;
		goto yy284;
yy564:
		YYDEBUG(564, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy565;
		if (yych != 'w') goto yy284;
yy565:
		YYDEBUG(565, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(566, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1106 "Zend/zend_language_scanner.l"
		{
	return T_NEW;
}
#line 5904 "Zend/zend_language_scanner.c"
yy567:
		YYDEBUG(567, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy568;
		if (yych != 'e') goto yy284;
yy568:
		YYDEBUG(568, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy569;
		if (yych != 's') goto yy284;
yy569:
		YYDEBUG(569, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy570;
		if (yych != 'p') goto yy284;
yy570:
		YYDEBUG(570, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy571;
		if (yych != 'a') goto yy284;
yy571:
		YYDEBUG(571, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy572;
		if (yych != 'c') goto yy284;
yy572:
		YYDEBUG(572, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy573;
		if (yych != 'e') goto yy284;
yy573:
		YYDEBUG(573, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(574, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1170 "Zend/zend_language_scanner.l"
		{
	return T_NAMESPACE;
}
#line 5947 "Zend/zend_language_scanner.c"
yy575:
		YYDEBUG(575, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(576, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1102 "Zend/zend_language_scanner.l"
		{
	return T_PAAMAYIM_NEKUDOTAYIM;
}
#line 5957 "Zend/zend_language_scanner.c"
yy577:
		YYDEBUG(577, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy578:
		YYDEBUG(578, *YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy225;
			if (yych <= '\n') goto yy577;
			goto yy225;
		} else {
			if (yych <= '\r') goto yy577;
			if (yych == ' ') goto yy577;
			goto yy225;
		}
yy579:
		YYDEBUG(579, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(580, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1270 "Zend/zend_language_scanner.l"
		{
	return T_MINUS_EQUAL;
}
#line 5983 "Zend/zend_language_scanner.c"
yy581:
		YYDEBUG(581, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(582, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1238 "Zend/zend_language_scanner.l"
		{
	return T_DEC;
}
#line 5993 "Zend/zend_language_scanner.c"
yy583:
		YYDEBUG(583, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(584, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1072 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	return T_OBJECT_OPERATOR;
}
#line 6004 "Zend/zend_language_scanner.c"
yy585:
		YYDEBUG(585, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy592;
			if (yych <= 'N') goto yy284;
			goto yy593;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy284;
				goto yy592;
			} else {
				if (yych == 'o') goto yy593;
				goto yy284;
			}
		}
yy586:
		YYDEBUG(586, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy587;
		if (yych != 'b') goto yy284;
yy587:
		YYDEBUG(587, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy588;
		if (yych != 'l') goto yy284;
yy588:
		YYDEBUG(588, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy589;
		if (yych != 'i') goto yy284;
yy589:
		YYDEBUG(589, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy590;
		if (yych != 'c') goto yy284;
yy590:
		YYDEBUG(590, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(591, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1214 "Zend/zend_language_scanner.l"
		{
	return T_PUBLIC;
}
#line 6053 "Zend/zend_language_scanner.c"
yy592:
		YYDEBUG(592, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'V') {
			if (yych == 'N') goto yy601;
			if (yych <= 'U') goto yy284;
			goto yy602;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy284;
				goto yy601;
			} else {
				if (yych == 'v') goto yy602;
				goto yy284;
			}
		}
yy593:
		YYDEBUG(593, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy594;
		if (yych != 't') goto yy284;
yy594:
		YYDEBUG(594, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy595;
		if (yych != 'e') goto yy284;
yy595:
		YYDEBUG(595, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy596;
		if (yych != 'c') goto yy284;
yy596:
		YYDEBUG(596, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy597;
		if (yych != 't') goto yy284;
yy597:
		YYDEBUG(597, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy598;
		if (yych != 'e') goto yy284;
yy598:
		YYDEBUG(598, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy599;
		if (yych != 'd') goto yy284;
yy599:
		YYDEBUG(599, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(600, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1210 "Zend/zend_language_scanner.l"
		{
	return T_PROTECTED;
}
#line 6112 "Zend/zend_language_scanner.c"
yy601:
		YYDEBUG(601, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy607;
		if (yych == 't') goto yy607;
		goto yy284;
yy602:
		YYDEBUG(602, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy603;
		if (yych != 'a') goto yy284;
yy603:
		YYDEBUG(603, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy604;
		if (yych != 't') goto yy284;
yy604:
		YYDEBUG(604, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy605;
		if (yych != 'e') goto yy284;
yy605:
		YYDEBUG(605, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(606, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1206 "Zend/zend_language_scanner.l"
		{
	return T_PRIVATE;
}
#line 6146 "Zend/zend_language_scanner.c"
yy607:
		YYDEBUG(607, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(608, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1052 "Zend/zend_language_scanner.l"
		{
	return T_PRINT;
}
#line 6159 "Zend/zend_language_scanner.c"
yy609:
		YYDEBUG(609, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy614;
		if (yych == 'o') goto yy614;
		goto yy284;
yy610:
		YYDEBUG(610, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy611;
		if (yych != 't') goto yy284;
yy611:
		YYDEBUG(611, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy612;
		if (yych != 'o') goto yy284;
yy612:
		YYDEBUG(612, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(613, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1044 "Zend/zend_language_scanner.l"
		{
	return T_GOTO;
}
#line 6188 "Zend/zend_language_scanner.c"
yy614:
		YYDEBUG(614, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy615;
		if (yych != 'b') goto yy284;
yy615:
		YYDEBUG(615, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy616;
		if (yych != 'a') goto yy284;
yy616:
		YYDEBUG(616, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy617;
		if (yych != 'l') goto yy284;
yy617:
		YYDEBUG(617, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(618, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1178 "Zend/zend_language_scanner.l"
		{
	return T_GLOBAL;
}
#line 6216 "Zend/zend_language_scanner.c"
yy619:
		YYDEBUG(619, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy626;
		goto yy274;
yy620:
		YYDEBUG(620, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy276;
yy621:
		YYDEBUG(621, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy622;
		if (yych != 'e') goto yy284;
yy622:
		YYDEBUG(622, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy623;
		if (yych != 'a') goto yy284;
yy623:
		YYDEBUG(623, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'K') goto yy624;
		if (yych != 'k') goto yy284;
yy624:
		YYDEBUG(624, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(625, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1036 "Zend/zend_language_scanner.l"
		{
	return T_BREAK;
}
#line 6254 "Zend/zend_language_scanner.c"
yy626:
		YYDEBUG(626, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy363;
		goto yy274;
yy627:
		YYDEBUG(627, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy634;
		if (yych == 'a') goto yy634;
		goto yy284;
yy628:
		YYDEBUG(628, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy629;
		if (yych != 'i') goto yy284;
yy629:
		YYDEBUG(629, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy630;
		if (yych != 't') goto yy284;
yy630:
		YYDEBUG(630, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy631;
		if (yych != 'c') goto yy284;
yy631:
		YYDEBUG(631, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy632;
		if (yych != 'h') goto yy284;
yy632:
		YYDEBUG(632, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(633, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1020 "Zend/zend_language_scanner.l"
		{
	return T_SWITCH;
}
#line 6298 "Zend/zend_language_scanner.c"
yy634:
		YYDEBUG(634, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy635;
		if (yych != 't') goto yy284;
yy635:
		YYDEBUG(635, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy636;
		if (yych != 'i') goto yy284;
yy636:
		YYDEBUG(636, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy637;
		if (yych != 'c') goto yy284;
yy637:
		YYDEBUG(637, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(638, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1194 "Zend/zend_language_scanner.l"
		{
	return T_STATIC;
}
#line 6326 "Zend/zend_language_scanner.c"
yy639:
		YYDEBUG(639, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy650;
		if (yych == 's') goto yy650;
		goto yy284;
yy640:
		YYDEBUG(640, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy648;
		if (yych == 'd') goto yy648;
		goto yy284;
yy641:
		YYDEBUG(641, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy644;
		if (yych == 'r') goto yy644;
		goto yy284;
yy642:
		YYDEBUG(642, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(643, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1016 "Zend/zend_language_scanner.l"
		{
	return T_AS;
}
#line 6357 "Zend/zend_language_scanner.c"
yy644:
		YYDEBUG(644, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy645;
		if (yych != 'a') goto yy284;
yy645:
		YYDEBUG(645, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy646;
		if (yych != 'y') goto yy284;
yy646:
		YYDEBUG(646, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(647, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1230 "Zend/zend_language_scanner.l"
		{
	return T_ARRAY;
}
#line 6380 "Zend/zend_language_scanner.c"
yy648:
		YYDEBUG(648, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(649, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1322 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_AND;
}
#line 6393 "Zend/zend_language_scanner.c"
yy650:
		YYDEBUG(650, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy651;
		if (yych != 't') goto yy284;
yy651:
		YYDEBUG(651, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy652;
		if (yych != 'r') goto yy284;
yy652:
		YYDEBUG(652, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy653;
		if (yych != 'a') goto yy284;
yy653:
		YYDEBUG(653, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy654;
		if (yych != 'c') goto yy284;
yy654:
		YYDEBUG(654, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy655;
		if (yych != 't') goto yy284;
yy655:
		YYDEBUG(655, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(656, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1198 "Zend/zend_language_scanner.l"
		{
	return T_ABSTRACT;
}
#line 6431 "Zend/zend_language_scanner.c"
yy657:
		YYDEBUG(657, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy658;
		if (yych != 'i') goto yy284;
yy658:
		YYDEBUG(658, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy659;
		if (yych != 'l') goto yy284;
yy659:
		YYDEBUG(659, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy660;
		if (yych != 'e') goto yy284;
yy660:
		YYDEBUG(660, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(661, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 976 "Zend/zend_language_scanner.l"
		{
	return T_WHILE;
}
#line 6459 "Zend/zend_language_scanner.c"
yy662:
		YYDEBUG(662, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(663, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 960 "Zend/zend_language_scanner.l"
		{
	return T_IF;
}
#line 6472 "Zend/zend_language_scanner.c"
yy664:
		YYDEBUG(664, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy700;
		if (yych == 'p') goto yy700;
		goto yy284;
yy665:
		YYDEBUG(665, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'C') {
				if (yych <= 'B') goto yy284;
				goto yy673;
			} else {
				if (yych <= 'R') goto yy284;
				if (yych <= 'S') goto yy671;
				goto yy672;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'c') goto yy673;
				goto yy284;
			} else {
				if (yych <= 's') goto yy671;
				if (yych <= 't') goto yy672;
				goto yy284;
			}
		}
yy666:
		YYDEBUG(666, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy667;
		if (yych != 's') goto yy284;
yy667:
		YYDEBUG(667, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy668;
		if (yych != 'e') goto yy284;
yy668:
		YYDEBUG(668, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy669;
		if (yych != 't') goto yy284;
yy669:
		YYDEBUG(669, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(670, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1182 "Zend/zend_language_scanner.l"
		{
	return T_ISSET;
}
#line 6528 "Zend/zend_language_scanner.c"
yy671:
		YYDEBUG(671, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy692;
		if (yych == 't') goto yy692;
		goto yy284;
yy672:
		YYDEBUG(672, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy685;
		if (yych == 'e') goto yy685;
		goto yy284;
yy673:
		YYDEBUG(673, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy674;
		if (yych != 'l') goto yy284;
yy674:
		YYDEBUG(674, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy675;
		if (yych != 'u') goto yy284;
yy675:
		YYDEBUG(675, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy676;
		if (yych != 'd') goto yy284;
yy676:
		YYDEBUG(676, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy677;
		if (yych != 'e') goto yy284;
yy677:
		YYDEBUG(677, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy283;
			} else {
				if (yych <= '@') goto yy678;
				if (yych <= 'Z') goto yy283;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy679;
			} else {
				if (yych <= 'z') goto yy283;
				if (yych >= 0x7F) goto yy283;
			}
		}
yy678:
		YYDEBUG(678, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1154 "Zend/zend_language_scanner.l"
		{
	return T_INCLUDE;
}
#line 6586 "Zend/zend_language_scanner.c"
yy679:
		YYDEBUG(679, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy680;
		if (yych != 'o') goto yy284;
yy680:
		YYDEBUG(680, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy681;
		if (yych != 'n') goto yy284;
yy681:
		YYDEBUG(681, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy682;
		if (yych != 'c') goto yy284;
yy682:
		YYDEBUG(682, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy683;
		if (yych != 'e') goto yy284;
yy683:
		YYDEBUG(683, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(684, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1158 "Zend/zend_language_scanner.l"
		{
	return T_INCLUDE_ONCE;
}
#line 6619 "Zend/zend_language_scanner.c"
yy685:
		YYDEBUG(685, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy686;
		if (yych != 'r') goto yy284;
yy686:
		YYDEBUG(686, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy687;
		if (yych != 'f') goto yy284;
yy687:
		YYDEBUG(687, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy688;
		if (yych != 'a') goto yy284;
yy688:
		YYDEBUG(688, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy689;
		if (yych != 'c') goto yy284;
yy689:
		YYDEBUG(689, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy690;
		if (yych != 'e') goto yy284;
yy690:
		YYDEBUG(690, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(691, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1060 "Zend/zend_language_scanner.l"
		{
	return T_INTERFACE;
}
#line 6657 "Zend/zend_language_scanner.c"
yy692:
		YYDEBUG(692, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy693;
		if (yych != 'a') goto yy284;
yy693:
		YYDEBUG(693, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy694;
		if (yych != 'n') goto yy284;
yy694:
		YYDEBUG(694, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy695;
		if (yych != 'c') goto yy284;
yy695:
		YYDEBUG(695, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy696;
		if (yych != 'e') goto yy284;
yy696:
		YYDEBUG(696, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy697;
		if (yych != 'o') goto yy284;
yy697:
		YYDEBUG(697, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy698;
		if (yych != 'f') goto yy284;
yy698:
		YYDEBUG(698, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(699, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1012 "Zend/zend_language_scanner.l"
		{
	return T_INSTANCEOF;
}
#line 6700 "Zend/zend_language_scanner.c"
yy700:
		YYDEBUG(700, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy701;
		if (yych != 'l') goto yy284;
yy701:
		YYDEBUG(701, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy702;
		if (yych != 'e') goto yy284;
yy702:
		YYDEBUG(702, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy703;
		if (yych != 'm') goto yy284;
yy703:
		YYDEBUG(703, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy704;
		if (yych != 'e') goto yy284;
yy704:
		YYDEBUG(704, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy705;
		if (yych != 'n') goto yy284;
yy705:
		YYDEBUG(705, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy706;
		if (yych != 't') goto yy284;
yy706:
		YYDEBUG(706, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy707;
		if (yych != 's') goto yy284;
yy707:
		YYDEBUG(707, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(708, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1068 "Zend/zend_language_scanner.l"
		{
	return T_IMPLEMENTS;
}
#line 6748 "Zend/zend_language_scanner.c"
yy709:
		YYDEBUG(709, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy713;
		if (yych == 'r') goto yy713;
		goto yy284;
yy710:
		YYDEBUG(710, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy711;
		if (yych != 'y') goto yy284;
yy711:
		YYDEBUG(711, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(712, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 948 "Zend/zend_language_scanner.l"
		{
	return T_TRY;
}
#line 6772 "Zend/zend_language_scanner.c"
yy713:
		YYDEBUG(713, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy714;
		if (yych != 'o') goto yy284;
yy714:
		YYDEBUG(714, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy715;
		if (yych != 'w') goto yy284;
yy715:
		YYDEBUG(715, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(716, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 956 "Zend/zend_language_scanner.l"
		{
	return T_THROW;
}
#line 6795 "Zend/zend_language_scanner.c"
yy717:
		YYDEBUG(717, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych == 'Q') goto yy719;
			if (yych <= 'S') goto yy284;
		} else {
			if (yych <= 'q') {
				if (yych <= 'p') goto yy284;
				goto yy719;
			} else {
				if (yych != 't') goto yy284;
			}
		}
		YYDEBUG(718, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy731;
		if (yych == 'u') goto yy731;
		goto yy284;
yy719:
		YYDEBUG(719, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy720;
		if (yych != 'u') goto yy284;
yy720:
		YYDEBUG(720, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy721;
		if (yych != 'i') goto yy284;
yy721:
		YYDEBUG(721, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy722;
		if (yych != 'r') goto yy284;
yy722:
		YYDEBUG(722, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy723;
		if (yych != 'e') goto yy284;
yy723:
		YYDEBUG(723, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy283;
			} else {
				if (yych <= '@') goto yy724;
				if (yych <= 'Z') goto yy283;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy725;
			} else {
				if (yych <= 'z') goto yy283;
				if (yych >= 0x7F) goto yy283;
			}
		}
yy724:
		YYDEBUG(724, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1162 "Zend/zend_language_scanner.l"
		{
	return T_REQUIRE;
}
#line 6860 "Zend/zend_language_scanner.c"
yy725:
		YYDEBUG(725, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy726;
		if (yych != 'o') goto yy284;
yy726:
		YYDEBUG(726, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy727;
		if (yych != 'n') goto yy284;
yy727:
		YYDEBUG(727, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy728;
		if (yych != 'c') goto yy284;
yy728:
		YYDEBUG(728, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy729;
		if (yych != 'e') goto yy284;
yy729:
		YYDEBUG(729, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(730, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1166 "Zend/zend_language_scanner.l"
		{
	return T_REQUIRE_ONCE;
}
#line 6893 "Zend/zend_language_scanner.c"
yy731:
		YYDEBUG(731, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy732;
		if (yych != 'r') goto yy284;
yy732:
		YYDEBUG(732, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy733;
		if (yych != 'n') goto yy284;
yy733:
		YYDEBUG(733, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(734, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 944 "Zend/zend_language_scanner.l"
		{
	return T_RETURN;
}
#line 6916 "Zend/zend_language_scanner.c"
yy735:
		YYDEBUG(735, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'R') goto yy284;
			if (yych <= 'S') goto yy757;
			goto yy756;
		} else {
			if (yych <= 'r') goto yy284;
			if (yych <= 's') goto yy757;
			if (yych <= 't') goto yy756;
			goto yy284;
		}
yy736:
		YYDEBUG(736, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'A') goto yy748;
			if (yych <= 'N') goto yy284;
			goto yy749;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy284;
				goto yy748;
			} else {
				if (yych == 'o') goto yy749;
				goto yy284;
			}
		}
yy737:
		YYDEBUG(737, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy738;
		if (yych != 'n') goto yy284;
yy738:
		YYDEBUG(738, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'R') goto yy284;
			if (yych >= 'T') goto yy740;
		} else {
			if (yych <= 'r') goto yy284;
			if (yych <= 's') goto yy739;
			if (yych <= 't') goto yy740;
			goto yy284;
		}
yy739:
		YYDEBUG(739, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy746;
		if (yych == 't') goto yy746;
		goto yy284;
yy740:
		YYDEBUG(740, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy741;
		if (yych != 'i') goto yy284;
yy741:
		YYDEBUG(741, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy742;
		if (yych != 'n') goto yy284;
yy742:
		YYDEBUG(742, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy743;
		if (yych != 'u') goto yy284;
yy743:
		YYDEBUG(743, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy744;
		if (yych != 'e') goto yy284;
yy744:
		YYDEBUG(744, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(745, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1040 "Zend/zend_language_scanner.l"
		{
	return T_CONTINUE;
}
#line 7001 "Zend/zend_language_scanner.c"
yy746:
		YYDEBUG(746, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(747, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 940 "Zend/zend_language_scanner.l"
		{
	return T_CONST;
}
#line 7014 "Zend/zend_language_scanner.c"
yy748:
		YYDEBUG(748, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy753;
		if (yych == 's') goto yy753;
		goto yy284;
yy749:
		YYDEBUG(749, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy750;
		if (yych != 'n') goto yy284;
yy750:
		YYDEBUG(750, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy751;
		if (yych != 'e') goto yy284;
yy751:
		YYDEBUG(751, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(752, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1110 "Zend/zend_language_scanner.l"
		{
	return T_CLONE;
}
#line 7043 "Zend/zend_language_scanner.c"
yy753:
		YYDEBUG(753, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy754;
		if (yych != 's') goto yy284;
yy754:
		YYDEBUG(754, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(755, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1056 "Zend/zend_language_scanner.l"
		{
	return T_CLASS;
}
#line 7061 "Zend/zend_language_scanner.c"
yy756:
		YYDEBUG(756, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy760;
		if (yych == 'c') goto yy760;
		goto yy284;
yy757:
		YYDEBUG(757, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy758;
		if (yych != 'e') goto yy284;
yy758:
		YYDEBUG(758, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(759, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1028 "Zend/zend_language_scanner.l"
		{
	return T_CASE;
}
#line 7085 "Zend/zend_language_scanner.c"
yy760:
		YYDEBUG(760, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy761;
		if (yych != 'h') goto yy284;
yy761:
		YYDEBUG(761, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(762, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 952 "Zend/zend_language_scanner.l"
		{
	return T_CATCH;
}
#line 7103 "Zend/zend_language_scanner.c"
yy763:
		YYDEBUG(763, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy780;
		if (yych == 'n') goto yy780;
		goto yy284;
yy764:
		YYDEBUG(764, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy773;
		if (yych == 'r') goto yy773;
		goto yy284;
yy765:
		YYDEBUG(765, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy766;
		if (yych != 'n') goto yy284;
yy766:
		YYDEBUG(766, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy767;
		if (yych != 'c') goto yy284;
yy767:
		YYDEBUG(767, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy768;
		if (yych != 't') goto yy284;
yy768:
		YYDEBUG(768, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy769;
		if (yych != 'i') goto yy284;
yy769:
		YYDEBUG(769, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy770;
		if (yych != 'o') goto yy284;
yy770:
		YYDEBUG(770, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy771;
		if (yych != 'n') goto yy284;
yy771:
		YYDEBUG(771, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(772, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 936 "Zend/zend_language_scanner.l"
		{
	return T_FUNCTION;
}
#line 7158 "Zend/zend_language_scanner.c"
yy773:
		YYDEBUG(773, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy774;
				if (yych <= '9') goto yy283;
			} else {
				if (yych == 'E') goto yy775;
				if (yych <= 'Z') goto yy283;
			}
		} else {
			if (yych <= 'd') {
				if (yych != '`') goto yy283;
			} else {
				if (yych <= 'e') goto yy775;
				if (yych <= 'z') goto yy283;
				if (yych >= 0x7F) goto yy283;
			}
		}
yy774:
		YYDEBUG(774, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 988 "Zend/zend_language_scanner.l"
		{
	return T_FOR;
}
#line 7186 "Zend/zend_language_scanner.c"
yy775:
		YYDEBUG(775, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy776;
		if (yych != 'a') goto yy284;
yy776:
		YYDEBUG(776, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy777;
		if (yych != 'c') goto yy284;
yy777:
		YYDEBUG(777, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy778;
		if (yych != 'h') goto yy284;
yy778:
		YYDEBUG(778, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(779, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 996 "Zend/zend_language_scanner.l"
		{
	return T_FOREACH;
}
#line 7214 "Zend/zend_language_scanner.c"
yy780:
		YYDEBUG(780, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy781;
		if (yych != 'a') goto yy284;
yy781:
		YYDEBUG(781, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy782;
		if (yych != 'l') goto yy284;
yy782:
		YYDEBUG(782, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(783, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1202 "Zend/zend_language_scanner.l"
		{
	return T_FINAL;
}
#line 7237 "Zend/zend_language_scanner.c"
yy784:
		YYDEBUG(784, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'F') {
			if (yych == 'C') goto yy790;
			if (yych <= 'E') goto yy284;
			goto yy791;
		} else {
			if (yych <= 'c') {
				if (yych <= 'b') goto yy284;
				goto yy790;
			} else {
				if (yych == 'f') goto yy791;
				goto yy284;
			}
		}
yy785:
		YYDEBUG(785, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy788;
		if (yych == 'e') goto yy788;
		goto yy284;
yy786:
		YYDEBUG(786, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(787, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 984 "Zend/zend_language_scanner.l"
		{
	return T_DO;
}
#line 7272 "Zend/zend_language_scanner.c"
yy788:
		YYDEBUG(788, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(789, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 932 "Zend/zend_language_scanner.l"
		{
	return T_EXIT;
}
#line 7285 "Zend/zend_language_scanner.c"
yy790:
		YYDEBUG(790, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy797;
		if (yych == 'l') goto yy797;
		goto yy284;
yy791:
		YYDEBUG(791, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy792;
		if (yych != 'a') goto yy284;
yy792:
		YYDEBUG(792, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy793;
		if (yych != 'u') goto yy284;
yy793:
		YYDEBUG(793, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy794;
		if (yych != 'l') goto yy284;
yy794:
		YYDEBUG(794, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy795;
		if (yych != 't') goto yy284;
yy795:
		YYDEBUG(795, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(796, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1032 "Zend/zend_language_scanner.l"
		{
	return T_DEFAULT;
}
#line 7324 "Zend/zend_language_scanner.c"
yy797:
		YYDEBUG(797, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy798;
		if (yych != 'a') goto yy284;
yy798:
		YYDEBUG(798, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy799;
		if (yych != 'r') goto yy284;
yy799:
		YYDEBUG(799, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy800;
		if (yych != 'e') goto yy284;
yy800:
		YYDEBUG(800, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(801, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1004 "Zend/zend_language_scanner.l"
		{
	return T_DECLARE;
}
#line 7352 "Zend/zend_language_scanner.c"
yy802:
		YYDEBUG(802, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy864;
		if (yych == 'h') goto yy864;
		goto yy284;
yy803:
		YYDEBUG(803, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy858;
		if (yych == 's') goto yy858;
		goto yy284;
yy804:
		YYDEBUG(804, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy854;
		if (yych == 'p') goto yy854;
		goto yy284;
yy805:
		YYDEBUG(805, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy820;
		if (yych == 'd') goto yy820;
		goto yy284;
yy806:
		YYDEBUG(806, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy817;
		if (yych == 'a') goto yy817;
		goto yy284;
yy807:
		YYDEBUG(807, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych == 'I') goto yy808;
			if (yych <= 'S') goto yy284;
			goto yy809;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy284;
			} else {
				if (yych == 't') goto yy809;
				goto yy284;
			}
		}
yy808:
		YYDEBUG(808, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy815;
		if (yych == 't') goto yy815;
		goto yy284;
yy809:
		YYDEBUG(809, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy810;
		if (yych != 'e') goto yy284;
yy810:
		YYDEBUG(810, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy811;
		if (yych != 'n') goto yy284;
yy811:
		YYDEBUG(811, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy812;
		if (yych != 'd') goto yy284;
yy812:
		YYDEBUG(812, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy813;
		if (yych != 's') goto yy284;
yy813:
		YYDEBUG(813, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(814, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1064 "Zend/zend_language_scanner.l"
		{
	return T_EXTENDS;
}
#line 7436 "Zend/zend_language_scanner.c"
yy815:
		YYDEBUG(815, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(816, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 928 "Zend/zend_language_scanner.l"
		{
	return T_EXIT;
}
#line 7449 "Zend/zend_language_scanner.c"
yy817:
		YYDEBUG(817, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy818;
		if (yych != 'l') goto yy284;
yy818:
		YYDEBUG(818, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(819, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1150 "Zend/zend_language_scanner.l"
		{
	return T_EVAL;
}
#line 7467 "Zend/zend_language_scanner.c"
yy820:
		YYDEBUG(820, *YYCURSOR);
		yych = *++YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'D':
		case 'd':	goto yy821;
		case 'F':
		case 'f':	goto yy822;
		case 'I':
		case 'i':	goto yy823;
		case 'S':
		case 's':	goto yy824;
		case 'W':
		case 'w':	goto yy825;
		default:	goto yy284;
		}
yy821:
		YYDEBUG(821, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy847;
		if (yych == 'e') goto yy847;
		goto yy284;
yy822:
		YYDEBUG(822, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy839;
		if (yych == 'o') goto yy839;
		goto yy284;
yy823:
		YYDEBUG(823, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy837;
		if (yych == 'f') goto yy837;
		goto yy284;
yy824:
		YYDEBUG(824, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy831;
		if (yych == 'w') goto yy831;
		goto yy284;
yy825:
		YYDEBUG(825, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy826;
		if (yych != 'h') goto yy284;
yy826:
		YYDEBUG(826, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy827;
		if (yych != 'i') goto yy284;
yy827:
		YYDEBUG(827, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy828;
		if (yych != 'l') goto yy284;
yy828:
		YYDEBUG(828, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy829;
		if (yych != 'e') goto yy284;
yy829:
		YYDEBUG(829, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(830, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 980 "Zend/zend_language_scanner.l"
		{
	return T_ENDWHILE;
}
#line 7541 "Zend/zend_language_scanner.c"
yy831:
		YYDEBUG(831, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy832;
		if (yych != 'i') goto yy284;
yy832:
		YYDEBUG(832, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy833;
		if (yych != 't') goto yy284;
yy833:
		YYDEBUG(833, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy834;
		if (yych != 'c') goto yy284;
yy834:
		YYDEBUG(834, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy835;
		if (yych != 'h') goto yy284;
yy835:
		YYDEBUG(835, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(836, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1024 "Zend/zend_language_scanner.l"
		{
	return T_ENDSWITCH;
}
#line 7574 "Zend/zend_language_scanner.c"
yy837:
		YYDEBUG(837, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(838, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 968 "Zend/zend_language_scanner.l"
		{
	return T_ENDIF;
}
#line 7587 "Zend/zend_language_scanner.c"
yy839:
		YYDEBUG(839, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy840;
		if (yych != 'r') goto yy284;
yy840:
		YYDEBUG(840, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy841;
				if (yych <= '9') goto yy283;
			} else {
				if (yych == 'E') goto yy842;
				if (yych <= 'Z') goto yy283;
			}
		} else {
			if (yych <= 'd') {
				if (yych != '`') goto yy283;
			} else {
				if (yych <= 'e') goto yy842;
				if (yych <= 'z') goto yy283;
				if (yych >= 0x7F) goto yy283;
			}
		}
yy841:
		YYDEBUG(841, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 992 "Zend/zend_language_scanner.l"
		{
	return T_ENDFOR;
}
#line 7620 "Zend/zend_language_scanner.c"
yy842:
		YYDEBUG(842, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy843;
		if (yych != 'a') goto yy284;
yy843:
		YYDEBUG(843, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy844;
		if (yych != 'c') goto yy284;
yy844:
		YYDEBUG(844, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy845;
		if (yych != 'h') goto yy284;
yy845:
		YYDEBUG(845, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(846, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1000 "Zend/zend_language_scanner.l"
		{
	return T_ENDFOREACH;
}
#line 7648 "Zend/zend_language_scanner.c"
yy847:
		YYDEBUG(847, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy848;
		if (yych != 'c') goto yy284;
yy848:
		YYDEBUG(848, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy849;
		if (yych != 'l') goto yy284;
yy849:
		YYDEBUG(849, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy850;
		if (yych != 'a') goto yy284;
yy850:
		YYDEBUG(850, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy851;
		if (yych != 'r') goto yy284;
yy851:
		YYDEBUG(851, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy852;
		if (yych != 'e') goto yy284;
yy852:
		YYDEBUG(852, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(853, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1008 "Zend/zend_language_scanner.l"
		{
	return T_ENDDECLARE;
}
#line 7686 "Zend/zend_language_scanner.c"
yy854:
		YYDEBUG(854, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy855;
		if (yych != 't') goto yy284;
yy855:
		YYDEBUG(855, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy856;
		if (yych != 'y') goto yy284;
yy856:
		YYDEBUG(856, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(857, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1186 "Zend/zend_language_scanner.l"
		{
	return T_EMPTY;
}
#line 7709 "Zend/zend_language_scanner.c"
yy858:
		YYDEBUG(858, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy859;
		if (yych != 'e') goto yy284;
yy859:
		YYDEBUG(859, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy860;
				if (yych <= '9') goto yy283;
			} else {
				if (yych == 'I') goto yy861;
				if (yych <= 'Z') goto yy283;
			}
		} else {
			if (yych <= 'h') {
				if (yych != '`') goto yy283;
			} else {
				if (yych <= 'i') goto yy861;
				if (yych <= 'z') goto yy283;
				if (yych >= 0x7F) goto yy283;
			}
		}
yy860:
		YYDEBUG(860, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 972 "Zend/zend_language_scanner.l"
		{
	return T_ELSE;
}
#line 7742 "Zend/zend_language_scanner.c"
yy861:
		YYDEBUG(861, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy862;
		if (yych != 'f') goto yy284;
yy862:
		YYDEBUG(862, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(863, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 964 "Zend/zend_language_scanner.l"
		{
	return T_ELSEIF;
}
#line 7760 "Zend/zend_language_scanner.c"
yy864:
		YYDEBUG(864, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy865;
		if (yych != 'o') goto yy284;
yy865:
		YYDEBUG(865, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 8) {
			goto yy283;
		}
		YYDEBUG(866, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1048 "Zend/zend_language_scanner.l"
		{
	return T_ECHO;
}
#line 7778 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_PROPERTY:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,   0,   0,   0,   0,   0,   0, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
		};
		YYDEBUG(867, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '-') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy875;
				if (yych <= '\n') goto yy869;
				if (yych <= '\f') goto yy875;
			} else {
				if (yych == ' ') goto yy869;
				if (yych <= ',') goto yy875;
				goto yy871;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '@') goto yy875;
				if (yych <= 'Z') goto yy873;
				if (yych <= '^') goto yy875;
				goto yy873;
			} else {
				if (yych <= '`') goto yy875;
				if (yych <= 'z') goto yy873;
				if (yych <= '~') goto yy875;
				goto yy873;
			}
		}
yy869:
		YYDEBUG(869, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy881;
yy870:
		YYDEBUG(870, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1077 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_WHITESPACE;
}
#line 7859 "Zend/zend_language_scanner.c"
yy871:
		YYDEBUG(871, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy878;
yy872:
		YYDEBUG(872, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1096 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state(TSRMLS_C);
	goto restart;
}
#line 7873 "Zend/zend_language_scanner.c"
yy873:
		YYDEBUG(873, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy877;
yy874:
		YYDEBUG(874, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1089 "Zend/zend_language_scanner.l"
		{
	yy_pop_state(TSRMLS_C);
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 7889 "Zend/zend_language_scanner.c"
yy875:
		YYDEBUG(875, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy872;
yy876:
		YYDEBUG(876, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy877:
		YYDEBUG(877, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy876;
		}
		goto yy874;
yy878:
		YYDEBUG(878, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(879, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1085 "Zend/zend_language_scanner.l"
		{
	return T_OBJECT_OPERATOR;
}
#line 7914 "Zend/zend_language_scanner.c"
yy880:
		YYDEBUG(880, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy881:
		YYDEBUG(881, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy880;
		}
		goto yy870;
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_VARNAME:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(882, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy886;
			if (yych <= 'Z') goto yy884;
			if (yych <= '^') goto yy886;
		} else {
			if (yych <= '`') goto yy886;
			if (yych <= 'z') goto yy884;
			if (yych <= '~') goto yy886;
		}
yy884:
		YYDEBUG(884, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy889;
yy885:
		YYDEBUG(885, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1364 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	yy_pop_state(TSRMLS_C);
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_STRING_VARNAME;
}
#line 7992 "Zend/zend_language_scanner.c"
yy886:
		YYDEBUG(886, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(887, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1373 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state(TSRMLS_C);
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	goto restart;
}
#line 8005 "Zend/zend_language_scanner.c"
yy888:
		YYDEBUG(888, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy889:
		YYDEBUG(889, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy888;
		}
		goto yy885;
	}
/* *********************************** */
yyc_ST_NOWDOC:
	{
		static const unsigned char yybm[] = {
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,   8,  32,  32,  16,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 96,  96,  96,  96,  96,  96,  96,  96, 
			 96,  96,  32,  32,  32,  32,  32,  32, 
			 32, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192,  32,  32,  32,  32, 192, 
			 32, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192,  32,  32,  32,  32, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
			192, 192, 192, 192, 192, 192, 192, 192, 
		};
		YYDEBUG(890, *YYCURSOR);
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy896;
		}
		if (yych <= '\f') goto yy892;
		if (yych <= '\r') goto yy894;
		goto yy898;
yy892:
		YYDEBUG(892, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(893, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy896;
		}
		if (yych <= '\f') goto yy892;
		if (yych >= 0x0E) goto yy922;
yy894:
		YYDEBUG(894, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(895, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy896;
		}
		if (yych <= '\f') goto yy892;
		if (yych <= '\r') goto yy894;
		goto yy922;
yy896:
		YYDEBUG(896, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(897, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy896;
		}
		if (yych <= '\f') goto yy892;
		if (yych <= '\r') goto yy894;
		goto yy920;
yy898:
		YYDEBUG(898, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(899, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy898;
		}
		if (yych <= '\f') {
			if (yych != '\n') goto yy902;
		} else {
			if (yych <= '\r') goto yy900;
			if (yych == ';') goto yy901;
			goto yy902;
		}
yy900:
		YYDEBUG(900, *YYCURSOR);
yy901:
		YYDEBUG(901, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy900;
		if (yych == '\r') goto yy900;
		goto yy913;
yy902:
		YYDEBUG(902, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '^') {
			if (yych <= '\r') {
				if (yych >= '\r') goto yy894;
			} else {
				if (yych <= '@') goto yy903;
				if (yych <= 'Z') goto yy905;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy905;
			} else {
				if (yych <= 'z') goto yy905;
				if (yych >= 0x7F) goto yy905;
			}
		}
yy903:
		YYDEBUG(903, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(904, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '^') {
			if (yych <= '\r') {
				if (yych <= '\f') goto yy903;
				goto yy894;
			} else {
				if (yych <= '@') goto yy903;
				if (yych <= 'Z') goto yy907;
				goto yy903;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy907;
				goto yy903;
			} else {
				if (yych <= 'z') goto yy907;
				if (yych <= '~') goto yy903;
				goto yy907;
			}
		}
yy905:
		YYDEBUG(905, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(906, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '@') {
			if (yych <= '/') {
				if (yych == '\r') goto yy894;
				goto yy903;
			} else {
				if (yych <= '9') goto yy907;
				if (yych == ';') goto yy909;
				goto yy903;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy905;
				if (yych <= '^') goto yy903;
				goto yy905;
			} else {
				if (yych <= '`') goto yy903;
				if (yych <= 'z') goto yy905;
				if (yych <= '~') goto yy903;
				goto yy905;
			}
		}
yy907:
		YYDEBUG(907, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(908, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '@') {
			if (yych <= '/') {
				if (yych == '\r') goto yy894;
				goto yy903;
			} else {
				if (yych <= '9') goto yy907;
				if (yych != ';') goto yy903;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy907;
				if (yych <= '^') goto yy903;
				goto yy907;
			} else {
				if (yych <= '`') goto yy903;
				if (yych <= 'z') goto yy907;
				if (yych <= '~') goto yy903;
				goto yy907;
			}
		}
yy909:
		YYDEBUG(909, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(910, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '^') {
			if (yych <= '\r') {
				if (yych <= '\f') goto yy909;
				goto yy894;
			} else {
				if (yych <= '@') goto yy909;
				if (yych >= '[') goto yy909;
			}
		} else {
			if (yych <= '`') {
				if (yych >= '`') goto yy909;
			} else {
				if (yych <= 'z') goto yy911;
				if (yych <= '~') goto yy909;
			}
		}
yy911:
		YYDEBUG(911, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(912, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '\r') goto yy894;
				goto yy909;
			} else {
				if (yych <= '9') goto yy911;
				if (yych <= '@') goto yy909;
				goto yy911;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy911;
				goto yy909;
			} else {
				if (yych <= 'z') goto yy911;
				if (yych <= '~') goto yy909;
				goto yy911;
			}
		}
yy913:
		YYDEBUG(913, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '^') {
			if (yych <= '\r') {
				if (yych >= '\r') goto yy894;
			} else {
				if (yych <= '@') goto yy914;
				if (yych <= 'Z') goto yy916;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy916;
			} else {
				if (yych <= 'z') goto yy916;
				if (yych >= 0x7F) goto yy916;
			}
		}
yy914:
		YYDEBUG(914, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(915, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '^') {
			if (yych <= '\r') {
				if (yych <= '\f') goto yy914;
				goto yy894;
			} else {
				if (yych <= '@') goto yy914;
				if (yych <= 'Z') goto yy918;
				goto yy914;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy918;
				goto yy914;
			} else {
				if (yych <= 'z') goto yy918;
				if (yych <= '~') goto yy914;
				goto yy918;
			}
		}
yy916:
		YYDEBUG(916, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(917, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '@') {
			if (yych <= '/') {
				if (yych == '\r') goto yy894;
				goto yy909;
			} else {
				if (yych <= '9') goto yy918;
				if (yych == ';') goto yy914;
				goto yy909;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy916;
				if (yych <= '^') goto yy909;
				goto yy916;
			} else {
				if (yych <= '`') goto yy909;
				if (yych <= 'z') goto yy916;
				if (yych <= '~') goto yy909;
				goto yy916;
			}
		}
yy918:
		YYDEBUG(918, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(919, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '@') {
			if (yych <= '/') {
				if (yych == '\r') goto yy894;
				goto yy909;
			} else {
				if (yych <= '9') goto yy918;
				if (yych == ';') goto yy914;
				goto yy909;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy918;
				if (yych <= '^') goto yy909;
				goto yy918;
			} else {
				if (yych <= '`') goto yy909;
				if (yych <= 'z') goto yy918;
				if (yych <= '~') goto yy909;
				goto yy918;
			}
		}
yy920:
		YYDEBUG(920, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(921, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy892;
		}
		if (yych <= '@') {
			if (yych <= '/') {
				if (yych == '\r') goto yy894;
				goto yy903;
			} else {
				if (yych <= '9') goto yy920;
				if (yych == ';') goto yy914;
				goto yy903;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy920;
				if (yych <= '^') goto yy903;
				goto yy920;
			} else {
				if (yych <= '`') goto yy903;
				if (yych <= 'z') goto yy920;
				if (yych <= '~') goto yy903;
				goto yy920;
			}
		}
yy922:
		YYDEBUG(922, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(923, *YYCURSOR);
		if (yych <= ';') {
			if (yych <= '\r') {
				if (yych == '\n') goto yy925;
				if (yych <= '\f') goto yy902;
				goto yy925;
			} else {
				if (yych <= '/') goto yy902;
				if (yych <= '9') goto yy922;
				if (yych <= ':') goto yy902;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '@') goto yy902;
				if (yych <= 'Z') goto yy922;
				if (yych <= '^') goto yy902;
				goto yy922;
			} else {
				if (yych <= '`') goto yy902;
				if (yych <= 'z') goto yy922;
				if (yych <= '~') goto yy902;
				goto yy922;
			}
		}
		YYDEBUG(924, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych == '\n') goto yy925;
		if (yych != '\r') goto yy913;
yy925:
		YYDEBUG(925, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(926, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2113 "Zend/zend_language_scanner.l"
		{
	char *end = yytext + yyleng - 1;

	if (end[-1] == ';') {
		end--;
		yyleng--;
	}

	if (yyleng > CG(heredoc_len) && !memcmp(end - CG(heredoc_len), CG(heredoc), CG(heredoc_len))) {
		int len = yyleng - CG(heredoc_len) - 2; /* 2 for newline before and after label */

		/* May have matched fooLABEL; make sure there's a newline before it */
		if (yytext[len] != '\n') {
			if (yytext[len] != '\r') {
				yyless(yyleng - 1);
				yymore();
			}
		} else if (len > 0 && yytext[len - 1] == '\r') {
			len--; /* Windows newline */
		}

		/* Go back before last label char, to match in ST_END_NOWDOC state */
		yyless(yyleng - 2);

		/* Subtract the remaining label length. yyleng must include newline
		 * before label, for zend_highlight/strip, tokenizer, etc. */
		yyleng -= CG(heredoc_len) - 1;

		CG(increment_lineno) = 1; /* For newline before label */
		BEGIN(ST_END_NOWDOC);

		HANDLE_NEWLINES(yytext, len);
		zend_copy_value(zendlval, yytext, len);
		zendlval->type = IS_STRING;
		return T_ENCAPSED_AND_WHITESPACE;
	} else {
		/* Go back to end of label, so the next match works correctly in case of
		 * another label at the beginning of the next line */
		yyless(yyleng - 1);
		yymore();
	}
}
#line 8510 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_ONE_LINE_COMMENT:
	{
		static const unsigned char yybm[] = {
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0, 128, 128,   0, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128,   0, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(927, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy933;
		}
		if (yych <= '\f') goto yy936;
		if (yych <= '\r') goto yy937;
		if (yych <= '=') goto yy929;
		if (yych <= '>') goto yy931;
		goto yy932;
yy929:
		YYDEBUG(929, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy941;
yy930:
		YYDEBUG(930, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1731 "Zend/zend_language_scanner.l"
		{
	yymore();
}
#line 8571 "Zend/zend_language_scanner.c"
yy931:
		YYDEBUG(931, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy930;
yy932:
		YYDEBUG(932, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy941;
		goto yy930;
yy933:
		YYDEBUG(933, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(934, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy933;
		}
		goto yy940;
yy935:
		YYDEBUG(935, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1735 "Zend/zend_language_scanner.l"
		{
	switch (yytext[yyleng-1]) {
		case '?': case '%': case '>':
			yyless(yyleng-1);
			yymore();
			break;
		case '\n':
			CG(zend_lineno)++;
			/* intentional fall through */
		default:
			zendlval->value.str.val = yytext; /* no copying - intentional */
			zendlval->value.str.len = yyleng;
			zendlval->type = IS_STRING;
			BEGIN(ST_IN_SCRIPTING);
			return T_COMMENT;
	}
}
#line 8612 "Zend/zend_language_scanner.c"
yy936:
		YYDEBUG(936, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy935;
yy937:
		YYDEBUG(937, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '\n') goto yy935;
		YYDEBUG(938, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(939, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1753 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(ST_IN_SCRIPTING);
	CG(zend_lineno)++;
	return T_COMMENT;
}
#line 8634 "Zend/zend_language_scanner.c"
yy940:
		YYDEBUG(940, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy935;
yy941:
		YYDEBUG(941, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(942, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1762 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags) || yytext[yyleng-2] != '%') { /* asp comment? */
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng-2;
		zendlval->type = IS_STRING;
		yyless(yyleng - 2);
		BEGIN(ST_IN_SCRIPTING);
		return T_COMMENT;
	} else {
		yymore();
	}
}
#line 8657 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_START_HEREDOC:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(943, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy945;
			if (yych <= 'Z') goto yy947;
			if (yych >= '_') goto yy947;
		} else {
			if (yych <= '`') goto yy945;
			if (yych <= 'z') goto yy947;
			if (yych >= 0x7F) goto yy947;
		}
yy945:
		YYDEBUG(945, *YYCURSOR);
		++YYCURSOR;
yy946:
		YYDEBUG(946, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1927 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	BEGIN(ST_HEREDOC);
	goto restart;
}
#line 8720 "Zend/zend_language_scanner.c"
yy947:
		YYDEBUG(947, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy948;
		}
		if (yych <= '\f') {
			if (yych == '\n') goto yy952;
			goto yy946;
		} else {
			if (yych <= '\r') goto yy952;
			if (yych == ';') goto yy951;
			goto yy946;
		}
yy948:
		YYDEBUG(948, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(949, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy948;
		}
		if (yych <= '\f') {
			if (yych == '\n') goto yy952;
		} else {
			if (yych <= '\r') goto yy952;
			if (yych == ';') goto yy951;
		}
yy950:
		YYDEBUG(950, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy946;
yy951:
		YYDEBUG(951, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy952;
		if (yych != '\r') goto yy950;
yy952:
		YYDEBUG(952, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(953, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1933 "Zend/zend_language_scanner.l"
		{
	int label_len = yyleng - 1;

	if (yytext[label_len-1]==';') {
		label_len--;
	}

	yyless(label_len);

	if (label_len==CG(heredoc_len) && !memcmp(yytext, CG(heredoc), label_len)) {
		zendlval->value.str.val = CG(heredoc);
		zendlval->value.str.len = label_len;
		CG(heredoc)=NULL;
		CG(heredoc_len)=0;
		BEGIN(ST_IN_SCRIPTING);
		return T_END_HEREDOC;
	} else {
		BEGIN(ST_HEREDOC);
		yymore();
	}
}
#line 8787 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_START_NOWDOC:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(954, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy956;
			if (yych <= 'Z') goto yy958;
			if (yych >= '_') goto yy958;
		} else {
			if (yych <= '`') goto yy956;
			if (yych <= 'z') goto yy958;
			if (yych >= 0x7F) goto yy958;
		}
yy956:
		YYDEBUG(956, *YYCURSOR);
		++YYCURSOR;
yy957:
		YYDEBUG(957, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2087 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	BEGIN(ST_NOWDOC);
	goto restart;
}
#line 8850 "Zend/zend_language_scanner.c"
yy958:
		YYDEBUG(958, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy959;
		}
		if (yych <= '\f') {
			if (yych == '\n') goto yy963;
			goto yy957;
		} else {
			if (yych <= '\r') goto yy963;
			if (yych == ';') goto yy962;
			goto yy957;
		}
yy959:
		YYDEBUG(959, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(960, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy959;
		}
		if (yych <= '\f') {
			if (yych == '\n') goto yy963;
		} else {
			if (yych <= '\r') goto yy963;
			if (yych == ';') goto yy962;
		}
yy961:
		YYDEBUG(961, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy957;
yy962:
		YYDEBUG(962, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy963;
		if (yych != '\r') goto yy961;
yy963:
		YYDEBUG(963, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(964, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2093 "Zend/zend_language_scanner.l"
		{
	int label_len = yyleng - 1;

	if (yytext[label_len-1]==';') {
		label_len--;
	}

	if (label_len==CG(heredoc_len) && !memcmp(yytext, CG(heredoc), label_len)) {
		yyless(label_len-1);
		yyleng = 0;
		BEGIN(ST_END_NOWDOC);
		ZVAL_EMPTY_STRING(zendlval);
		return T_ENCAPSED_AND_WHITESPACE;
	} else {
		BEGIN(ST_NOWDOC);
		yyless(label_len);
		yymore();
	}
}
#line 8915 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_VAR_OFFSET:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			224, 224, 224, 224, 224, 224, 224, 224, 
			224, 224,   0,   0,   0,   0,   0,   0, 
			  0, 160, 160, 160, 160, 160, 160,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,   0,   0,   0,   0,  32, 
			  0, 160, 160, 160, 160, 160, 160,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,   0,   0,   0,   0,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
		};
		YYDEBUG(965, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '/') {
			if (yych <= ' ') {
				if (yych <= '\f') {
					if (yych <= 0x08) goto yy979;
					if (yych <= '\n') goto yy975;
					goto yy979;
				} else {
					if (yych <= '\r') goto yy975;
					if (yych <= 0x1F) goto yy979;
					goto yy975;
				}
			} else {
				if (yych <= '$') {
					if (yych <= '"') goto yy974;
					if (yych <= '#') goto yy975;
					goto yy970;
				} else {
					if (yych == '\'') goto yy975;
					goto yy974;
				}
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '@') {
					if (yych <= '0') goto yy967;
					if (yych <= '9') goto yy969;
					goto yy974;
				} else {
					if (yych <= 'Z') goto yy977;
					if (yych <= '[') goto yy974;
					goto yy975;
				}
			} else {
				if (yych <= '_') {
					if (yych <= ']') goto yy972;
					if (yych <= '^') goto yy974;
					goto yy977;
				} else {
					if (yych <= '`') goto yy974;
					if (yych <= 'z') goto yy977;
					if (yych <= '~') goto yy974;
					goto yy977;
				}
			}
		}
yy967:
		YYDEBUG(967, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'W') {
			if (yych <= '/') goto yy968;
			if (yych <= '9') goto yy990;
		} else {
			if (yych <= 'X') goto yy988;
			if (yych == 'x') goto yy988;
		}
yy968:
		YYDEBUG(968, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1423 "Zend/zend_language_scanner.l"
		{ /* Offset could be treated as a long */
	if (yyleng < MAX_LENGTH_OF_LONG - 1 || (yyleng == MAX_LENGTH_OF_LONG - 1 && strcmp(yytext, long_min_digits) < 0)) {
		zendlval->value.lval = strtol(yytext, NULL, 10);
		zendlval->type = IS_LONG;
	} else {
		zendlval->value.str.val = (char *)estrndup(yytext, yyleng);
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
	}
	return T_NUM_STRING;
}
#line 9028 "Zend/zend_language_scanner.c"
yy969:
		YYDEBUG(969, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy987;
yy970:
		YYDEBUG(970, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy971;
			if (yych <= 'Z') goto yy983;
			if (yych >= '_') goto yy983;
		} else {
			if (yych <= '`') goto yy971;
			if (yych <= 'z') goto yy983;
			if (yych >= 0x7F) goto yy983;
		}
yy971:
		YYDEBUG(971, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1706 "Zend/zend_language_scanner.l"
		{
	/* Only '[' can be valid, but returning other tokens will allow a more explicit parse error */
	return yytext[0];
}
#line 9053 "Zend/zend_language_scanner.c"
yy972:
		YYDEBUG(972, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(973, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1701 "Zend/zend_language_scanner.l"
		{
	yy_pop_state(TSRMLS_C);
	return ']';
}
#line 9064 "Zend/zend_language_scanner.c"
yy974:
		YYDEBUG(974, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy971;
yy975:
		YYDEBUG(975, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(976, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1711 "Zend/zend_language_scanner.l"
		{
	/* Invalid rule to return a more explicit parse error with proper line number */
	yyless(0);
	yy_pop_state(TSRMLS_C);
	ZVAL_EMPTY_STRING(zendlval); /* Empty since it won't be used */
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 9082 "Zend/zend_language_scanner.c"
yy977:
		YYDEBUG(977, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy982;
yy978:
		YYDEBUG(978, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1719 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 9097 "Zend/zend_language_scanner.c"
yy979:
		YYDEBUG(979, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(980, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2179 "Zend/zend_language_scanner.l"
		{
	zend_error(E_COMPILE_WARNING,"Unexpected character in input:  '%c' (ASCII=%d) state=%d", yytext[0], yytext[0], YYSTATE);
	goto restart;
}
#line 9108 "Zend/zend_language_scanner.c"
yy981:
		YYDEBUG(981, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy982:
		YYDEBUG(982, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy981;
		}
		goto yy978;
yy983:
		YYDEBUG(983, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(984, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy983;
			} else {
				if (yych <= '@') goto yy985;
				if (yych <= 'Z') goto yy983;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy983;
			} else {
				if (yych <= 'z') goto yy983;
				if (yych >= 0x7F) goto yy983;
			}
		}
yy985:
		YYDEBUG(985, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1695 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 9150 "Zend/zend_language_scanner.c"
yy986:
		YYDEBUG(986, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy987:
		YYDEBUG(987, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy986;
		}
		goto yy968;
yy988:
		YYDEBUG(988, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy993;
		}
		YYDEBUG(989, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy968;
yy990:
		YYDEBUG(990, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(991, *YYCURSOR);
		if (yych <= '/') goto yy992;
		if (yych <= '9') goto yy990;
yy992:
		YYDEBUG(992, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1435 "Zend/zend_language_scanner.l"
		{ /* Offset must be treated as a string */
	zendlval->value.str.val = (char *)estrndup(yytext, yyleng);
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	return T_NUM_STRING;
}
#line 9189 "Zend/zend_language_scanner.c"
yy993:
		YYDEBUG(993, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(994, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy993;
		}
		goto yy992;
	}
}
#line 2184 "Zend/zend_language_scanner.l"

}
